// pages/rank/rank.js
const app = getApp();
const api = require('../../../api/api.js');
import * as echarts from '../../ec-canvas/echarts';
var dataList = [];

Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '买家排名', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    filterType: 0, //过滤类型（0：按天；1：按月；2：按季度；3：按年）
    enterType: 0, //进入类型（0：买家排行；1：商品排行；2：帮卖排行；3：供应商排名；4：订单收入对比；5：订单支出对比
    years: ['2015', '2016', '2017', '2018', '2019', '2020', '2021', '2022', '2023', '2024',
      '2025', '2026', '2027', '2028', '2029', '2030'
    ],
    year: new Date().getFullYear(),
    month: new Date().getMonth() + 1,
    quarters: ['第1季度', '第2季度', '第3季度', '第4季度'], //季度列表
    quarter: 1, //季度
    ec: {
      lazyLoad: true // 延迟加载
    },
    show: false,
    currentDate: new Date().getTime(),
    xData: [], //X轴数据
    yData: [], //Y轴数据
    Income_list: [], //统计分析收入列表
    Income_money: '', //收入金额
    Expenditure_list: [], //统计分析支出列表
    Expenditure_money: '', //支出金额
    Buyer_ranking: [], //买家排名数组
    Commodity_ranking: [], //商品排名数组
    Help_sell_ranking: [], //帮卖排名数组
    Supplier_ranking: [], //供货商排名数组
    order_list: [], //订单收入数组
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    let that = this;
    let key = `navbarData.title`
    this.setData({
      [key]: options.title,
      enterType: Number(options.enterType),
      filterType: Number(options.filterType)
    })
    if (that.data.enterType == 0) {
      // 获取买家排名
      that.getBuyer_ranking()
    } else if (that.data.enterType == 1) {
      // 获取商品排名
      that.getCommodity_ranking()
    } else if (that.data.enterType == 2) {
      // 获取帮卖排名
      that.getHelp_sell_ranking()
    } else if (that.data.enterType == 3) {
      // 获取供应商排名
      that.getSupplier_ranking()
    } else if (that.data.enterType == 4) {
      that.echartsComponnet = that.selectComponent('#mychart2');
      // 获取统计分析收入
      that.getIncome_list()
      // 获取订单收入列表
      that.getorder_list()
    } else if (that.data.enterType == 5) {
      that.echartsComponnet = that.selectComponent('#mychart2');
      // 获取统计分析支出
      that.getExpenditure_list()
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },

  // 改变过滤条件
  changeFilterType(e) {
    let that = this;
    that.setData({
      filterType: Number(e.target.dataset.type)
    })
    if (that.data.enterType == 0) {
      // 获取买家排名
      that.getBuyer_ranking()
    } else if (that.data.enterType == 1) {
      // 获取商品排名
      that.getCommodity_ranking()
    } else if (that.data.enterType == 2) {
      // 获取帮卖排名
      that.getHelp_sell_ranking()
    } else if (that.data.enterType == 3) {
      // 获取供应商排名
      that.getSupplier_ranking()
    } else if (that.data.enterType == 4) {
      // 获取统计分析收入
      that.getIncome_list()
      // 获取订单收入列表
      that.getorder_list()
    } else if (that.data.enterType == 5) {
      // 获取统计分析支出
      that.getExpenditure_list()
    }
  },
  // 获取买家排名
  getBuyer_ranking() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.Buyer_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Buyer_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.Buyer_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: year
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Buyer_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 获取商品排名
  getCommodity_ranking() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.Commodity_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Commodity_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 2) {
      //季度模式
      wx.request({
        url: api.Commodity_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          quarter: that.data.quarter
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Commodity_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.Commodity_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: that.data.year
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Commodity_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 获取帮卖排名
  getHelp_sell_ranking() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.Help_sell_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Help_sell_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.Help_sell_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: year
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Help_sell_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 获取供货商排名
  getSupplier_ranking() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.Supplier_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Supplier_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.Supplier_ranking,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: year
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              Supplier_ranking: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 获取统计分析收入
  getIncome_list() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.Income_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data.data;
            let xData = [];
            let yData = [];
            for (let i = 0; i < arr.length; i++) {
              xData.push(arr[i].date);
              yData.push(arr[i].price);
            }
            that.setData({
              Income_money: res.data.data.money,
              Income_list: res.data.data.data,
              xData,
              yData
            })
            dataList = res.data.data.data;
            that.init_echarts(); //初始化图表
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 2) {
      //季度模式
      wx.request({
        url: api.Income_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          quarter: that.data.quarter
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data.data;
            let xData = [];
            let yData = [];
            for (let i = 0; i < arr.length; i++) {
              xData.push(arr[i].date);
              yData.push(arr[i].price);
            }
            that.setData({
              Income_money: res.data.data.money,
              Income_list: res.data.data.data,
              xData,
              yData
            })
            dataList = res.data.data.data;
            that.init_echarts(); //初始化图表
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.Income_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: year
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data.data;
            let xData = [];
            let yData = [];
            for (let i = 0; i < arr.length; i++) {
              xData.push(arr[i].date);
              yData.push(arr[i].price);
            }
            that.setData({
              Income_money: res.data.data.money,
              Income_list: res.data.data.data,
              xData,
              yData
            })
            dataList = res.data.data.data;
            that.init_echarts(); //初始化图表
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 获取统计分析支出
  getExpenditure_list() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.Expenditure_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data.data;
            let xData = [];
            let yData = [];
            for (let i = 0; i < arr.length; i++) {
              xData.push(arr[i].date);
              yData.push(arr[i].price);
            }
            that.setData({
              Expenditure_money: res.data.data.money,
              Expenditure_list: res.data.data.data,
              xData,
              yData
            })
            dataList = res.data.data.data;
            that.init_echarts(); //初始化图表
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 2) {
      //季度模式
      wx.request({
        url: api.Expenditure_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          quarter: that.data.quarter
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data.data;
            let xData = [];
            let yData = [];
            for (let i = 0; i < arr.length; i++) {
              xData.push(arr[i].date);
              yData.push(arr[i].price);
            }
            that.setData({
              Expenditure_money: res.data.data.money,
              Expenditure_list: res.data.data.data,
              xData,
              yData
            })
            dataList = res.data.data.data;
            that.init_echarts(); //初始化图表
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.Expenditure_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: year
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data.data;
            let xData = [];
            let yData = [];
            for (let i = 0; i < arr.length; i++) {
              xData.push(arr[i].date);
              yData.push(arr[i].price);
            }
            that.setData({
              Expenditure_money: res.data.data.money,
              Expenditure_list: res.data.data.data,
              xData,
              yData
            })
            dataList = res.data.data.data;
            that.init_echarts(); //初始化图表
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 初始化图表
  init_echarts() {
    let that = this;
    that.echartsComponnet.init((canvas, width, height, dpr) => {
      // 初始化图表
      const Chart = echarts.init(canvas, null, {
        width: width,
        height: height,
        devicePixelRatio: dpr // new
      })
      Chart.setOption(that.getOption());
      return Chart;
    })
  },
  // 图表配置项
  getOption() {
    let that = this;
    var option = {
      tooltip: {
        trigger: 'axis'
      },
      xAxis: {
        type: 'category',
        boundaryGap: false,
        data: that.data.xData
      },
      yAxis: {
        show: false
      },
      series: [{
        data: that.data.yData,
        type: 'line',
        smooth: true,
        symbolSize: 10,
        lineStyle: {
          normal: {
            color: '#FF874E',
            width: 4
          }
        },
        itemStyle: {
          borderWidth: 3,
          borderColor: '',
          color: '#FF874E'
        },
        areaStyle: {
          color: {
            type: 'linear',
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
                offset: 0,
                color: '#FF874E' // 0% 处的颜色
              },
              {
                offset: 1,
                color: '#FFFFFF' // 100% 处的颜色
              }
            ],
            globalCoord: false // 缺省为 false
          },
          opacity: 0.5
        }
      }]
    }
    return option;
  },
  // 获取订单收入列表
  getorder_list() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    let year = that.data.year;
    let month = that.data.month;
    if (month < 10) {
      month = '0' + month
    }
    if (that.data.filterType == 1) {
      //月份模式
      wx.request({
        url: api.order_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          month: year + '-' + month
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              order_list: res.data.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (that.data.filterType == 3) {
      //年份模式
      wx.request({
        url: api.order_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          year: year
        },
        success(res) {
          wx.hideLoading()
          // console.log(res);
          if (res.data.code === 1) {
            that.setData({
              order_list: res.data.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 显示选择器
  showtime() {
    this.setData({
      show: true
    })
  },
  // 确认月
  oktime(e) {
    let that = this;
    let timec = e.detail;
    let date = new Date(timec);
    let year = date.getFullYear();
    let month = date.getMonth() + 1;
    that.setData({
      year: year,
      month: month,
      show: false
    })
    if (that.data.enterType == 0) {
      // 获取买家排名
      that.getBuyer_ranking()
    } else if (that.data.enterType == 1) {
      // 获取商品排名
      that.getCommodity_ranking()
    } else if (that.data.enterType == 2) {
      // 获取帮卖排名
      that.getHelp_sell_ranking()
    } else if (that.data.enterType == 3) {
      // 获取供应商排名
      that.getSupplier_ranking()
    } else if (that.data.enterType == 4) {
      // 获取统计分析收入
      that.getIncome_list()
      // 获取订单收入列表
      that.getorder_list()
    } else if (that.data.enterType == 5) {
      // 获取统计分析支出
      that.getExpenditure_list()
    }
  },
  // 确认季度
  okquarter(e) {
    let that = this;
    let quarter = e.detail.index + 1;
    that.setData({
      quarter: quarter,
      show: false
    })
  },
  // 确认年
  okyear(e) {
    let that = this;
    let year = e.detail.value;
    that.setData({
      year: year,
      show: false
    })
    if (that.data.enterType == 0) {
      // 获取买家排名
      that.getBuyer_ranking()
    } else if (that.data.enterType == 1) {
      // 获取商品排名
      that.getCommodity_ranking()
    } else if (that.data.enterType == 2) {
      // 获取帮卖排名
      that.getHelp_sell_ranking()
    } else if (that.data.enterType == 3) {
      // 获取供应商排名
      that.getSupplier_ranking()
    } else if (that.data.enterType == 4) {
      // 获取统计分析收入
      that.getIncome_list()
      // 获取订单收入列表
      that.getorder_list()
    } else if (that.data.enterType == 5) {
      // 获取统计分析支出
      that.getExpenditure_list()
    }
  },
  // 关闭选择器
  offtime() {
    this.setData({
      show: false
    })
  },
})