// pages/addaddress/addaddress.js
const api = require("../../api/api");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '新增地址', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    genders: ['男士', '女士'],
    type: '', //类型
    /* 表单 */
    id: 0, //id
    address: '', //地址名称/门牌号
    receiving_name: '', //收货人姓名
    genderIndex: 0,
    receiving_phone: '', //收货人手机号
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log(options.type);
    if (options.type === 'edit') {
      this.setData({
        type: 'edit',
        id: wx.getStorageSync('address').id,
        address: wx.getStorageSync('address').receiving_address,
        receiving_name: wx.getStorageSync('address').receiving_name,
        genderIndex: wx.getStorageSync('address').gender,
        receiving_phone: wx.getStorageSync('address').receiving_phone,
        navbarData: {
          showCapsule: 1,
          title: '修改地址',
          capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
        }
      })
    } else {
      this.setData({
        type: 'add',
        navbarData: {
          showCapsule: 1,
          title: '新增地址',
          capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 输入地址/门牌号
  inputAddress(e) {
    this.setData({
      address: e.detail.value
    })
  },
  // 输入姓名
  inputName(e) {
    this.setData({
      receiving_name: e.detail.value
    })
  },
  // 选择性别
  selectGender(e) {
    this.setData({
      genderIndex: e.currentTarget.dataset.index
    })
  },
  // 输入手机号
  inputPhone(e) {
    this.setData({
      receiving_phone: e.detail.value
    })
  },
  // 保持地址
  submitAdd() {
    let that = this;
    if (that.data.address == '') {
      wx.showToast({
        title: '提货点地址未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.receiving_name == '') {
      wx.showToast({
        title: '姓名未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.receiving_phone == '') {
      wx.showToast({
        title: '手机号未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Address_add,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        receiving_name: that.data.receiving_name,
        receiving_phone: that.data.receiving_phone,
        receiving_address: that.data.address,
        gender: that.data.genderIndex
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            icon: 'success',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 修改地址
  submitEdit() {
    let that = this;
    if (that.data.address == '') {
      wx.showToast({
        title: '地址未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.receiving_name == '') {
      wx.showToast({
        title: '姓名未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.receiving_phone == '') {
      wx.showToast({
        title: '手机号未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Address_edit,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.id,
        receiving_name: that.data.receiving_name,
        receiving_phone: that.data.receiving_phone,
        receiving_address: that.data.address,
        gender: that.data.genderIndex
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            icon: 'success',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  }
})