// pages/adminlist/adminlist.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '切换账号', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    Administrators_list: [], //管理员列表
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.getAdministrators_list()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  getAdministrators_list() {
    let that = this;
    // 管理员列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Administrators_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            Administrators_list: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 切换账号
  switchAccount(e) {
    let that = this;
    let admin_id = Number(e.currentTarget.dataset.id);
    wx.showLoading({
      title: '切换中',
      mask: true
    })
    wx.request({
      url: api.get_token,
      data: {
        id: admin_id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          wx.setStorageSync('token', res.data.data);
          // 获取用户个人信息-开始
          wx.showLoading({
            title: '登录中',
            mask: true
          })
          wx.request({
            url: api.user_info,
            header: {
              'Authorization': wx.getStorageSync('token')
            },
            data: {
              id: admin_id
            },
            success(res) {
              wx.hideLoading()
              console.log(res);
              if (res.data.code === 1) {
                wx.setStorageSync('login', true);
                wx.setStorageSync('userinfo', res.data.data);
                wx.showToast({
                  title: '切换成功',
                  icon: 'success',
                  mask: true,
                  success() {
                    setTimeout(() => {
                      wx.reLaunch({
                        url: '/pages/mine/mine',
                      })
                    }, 1500)
                  }
                })
              } else {
                wx.showToast({
                  title: res.data.msg,
                  mask: true,
                  icon: 'none'
                })
              }
            },
            fail(err) {
              wx.hideLoading()
              wx.showToast({
                title: '发起网络请求失败',
                icon: 'none',
                mask: true
              })
            },
            complete() {
              // wx.hideLoading()
            }
            // 获取用户个人信息-结束
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  }
})