// pages/adminmanage/adminmanage.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '管理员管理', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    Administrators_list: [], //管理员列表
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.getAdministrators_list()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    let user_id = wx.getStorageSync('userinfo').id; //邀请人ID
    let user_name = wx.getStorageSync('userinfo').name; //邀请人姓名
    let user_avatar = wx.getStorageSync('userinfo').headimg; //邀请人头像
    return {
      title: '邀请您成为我的管理员',
      path: '/pages/bindadmin/bindadmin?user_id=' + user_id + '&user_name=' + user_name + '&user_avatar=' + user_avatar,
      imageUrl: 'https://s4.ax1x.com/2021/12/29/TccgfK.jpg'
    }
  },
  getAdministrators_list() {
    let that = this;
    // 管理员列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Administrators_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            Administrators_list: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  deleteAdmin(e) {
    let that = this;
    let admin_id = e.currentTarget.dataset.id;
    wx.showLoading({
      title: '删除中',
      mask: true
    })
    wx.request({
      url: api.Administrators_delete,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: admin_id
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '删除成功',
            mask: true,
            success() {
              setTimeout(()=>{
                that.getAdministrators_list()
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  }
})