// pages/bindadmin/bindadmin.js
const api = require("../../api/api");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 0, //是否显示左上角图标   1表示显示    0表示不显示
      title: '成为管理员', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    user_name: '', //邀请人姓名
    user_avatar: '', //头像
    user_id: 0, //邀请人ID
    admin_id: 0, //管理员ID
    code: '', //小程序授权Code
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    // console.log(options);
    this.setData({
      user_name: options.user_name,
      user_avatar: options.user_avatar,
      user_id: Number(options.user_id)
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    let that = this;
    if (!wx.getStorageSync('login')) {
      that.getCode()
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 获取小程序授权Code
  getCode() {
    let that = this;
    wx.login({
      success(res) {
        console.log(res);
        if (res.errMsg.search('ok')) {
          that.setData({
            code: res.code
          })
        } else {
          wx.showToast({
            title: res.errMsg,
            icon: 'error',
            mask: true
          })
        }
      }
    })
  },
  // 绑定管理员
  bindAdmin() {
    let that = this;
    // 检查用户是否登录
    if (wx.getStorageSync('login') && wx.getStorageSync('userinfo')) {
      // 用户已登录
      let admin_id = wx.getStorageSync('userinfo').id;
      wx.showLoading({
        title: '正在绑定',
        mask: true
      })
      wx.request({
        url: api.Administrators_add,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          user_id: that.data.user_id,
          admin_id: admin_id
        },
        success(res) {
          console.log(res);
          wx.hideLoading()
          if (res.data.code === 1) {
            wx.showToast({
              title: '提交成功',
              icon: 'success',
              mask: true,
              success() {
                setTimeout(() => {
                  wx.reLaunch({
                    url: '/pages/mine/mine',
                  })
                }, 1500)
              }
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else {
      // 用户未登录
      that.login()
    }
  },
  // 用户登录
  login() {
    let that = this;
    wx.getUserProfile({
      desc: '登录',
      success: (res) => {
        // console.log(res);
        wx.showLoading({
          title: '登录中',
          mask: true
        })
        wx.request({
          url: api.weChatLogin,
          data: {
            code: that.data.code,
            headimg: res.userInfo.avatarUrl,
            name: res.userInfo.nickName
          },
          method: 'POST',
          success(res) {
            console.log(res);
            if (res.data.code === 1) {
              wx.setStorageSync('token', res.data.data);
              // 获取用户个人信息-开始
              wx.showLoading({
                title: '登录中',
                mask: true
              })
              wx.request({
                url: api.user_info,
                header: {
                  'Authorization': wx.getStorageSync('token')
                },
                success(res) {
                  console.log(res);
                  if (res.data.code === 1) {
                    wx.setStorageSync('login', true);
                    wx.setStorageSync('userinfo', res.data.data);
                    // 登录并获取个人信息成功，开始绑定管理员
                    that.bindAdmin()
                  } else {
                    wx.showToast({
                      title: res.data.msg,
                      mask: true,
                      icon: 'none'
                    })
                  }
                },
                fail(err) {
                  wx.showToast({
                    title: '发起网络请求失败',
                    icon: 'none',
                    mask: true
                  })
                },
                complete() {
                  wx.hideLoading()
                }
                // 获取用户个人信息-结束
              })
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail(err) {
            console.log(err);
          },
          complete() {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },

})