// pages/cardverify/cardverify.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '订单核销', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    card_number: '', //卡券号
    code_result: '', //扫码返回结果
  },
  saoma() {
    wx.navigateTo({
      url: '/pages/verify/verify',
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    if(that.data.code_result != ''){
      wx.showLoading({
        title: '扫码成功',
        mask: true
      })
      wx.request({
        url: api.Orderwrite,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        data: {
          card_number: that.data.code_result,
          write_method: 0
        },
        method: 'POST',
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            wx.showToast({
              title: '核销成功',
              mask: true
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          that.setData({
            code_result: ''
          })
          // wx.hideLoading()
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  inputCardNumber(e) {
    this.setData({
      card_number: e.detail.value
    })
  },
  submit() {
    let that = this;
    if(that.data.card_number == '') {
      wx.showToast({
        title: '订单核销码未录入',
        mask: true,
        icon: 'none'
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Orderwrite,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        card_number: that.data.card_number,
        write_method: 2
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '核销成功',
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  }
})