// pages/companydetailgroup/companydetailgroup.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '收支明细', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    filterTime: ['全部', '近7天', '近30天', '近90天'], //过滤时间
    filterIndex: 0, //过滤索引
    showPicker: false,
    detail: {}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    this.getData()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  bindPickerChange(e) {
    this.setData({
      filterIndex: e.detail.value
    })
    this.getData()
  },
  // 获取数据
  getData() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Detailed_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        time: Number(that.data.filterIndex)
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            detail: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 跳转收支明细-订单
  navToCompanyDetail(e) {
    wx.navigateTo({
      url: '/pages/companydetail/companydetail?id=' + e.currentTarget.dataset.id
    })
  }
})