// pages/confirmorder/confirmorder.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '确认订单', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    tabType: 'wuliu', //tab类型
    showBottomBar: true, //显示底部栏
    showReceiptPlace: false, //显示选择收货地址
    showSelfMention: false, //显示自取点
    showPayTypePicker: false, //显示支付方式选择器
    payTypes: [], //支付方式列表
    payType: [0], //支付方式
    showEMTPopup: false, //显示EMT支付弹出层
    showOrderSuccessful: false, //显示下单成功弹出层
    btnDisabled: false, //确认支付按钮禁用
    /* 表单 */
    id: 0, //拼团id
    gang_name: '', //拼团名称
    head_phone: '', //团长手机号
    all_scribe_price: 0, //划线价格总价
    all_price: 0, //总价
    shopcart: [], //购物车
    remarks: '', //备注
    logistics_mode: 0, //物流方式（0没有物流，1取货点自提，2送货或者自提）
    expected_arrival_time: '', //预计到货时间
    user_name: '', //团长名称
    head_email: '', //团长邮箱
    order_number: '', //订单号
    editFormPhone:'',//预留手机号
    ziquAddress: [], //自取点列表
    ziquIndex: 0,
    peisongAddress: [], //配送列表
    peisongIndex: 0,

    order_id: 0, //订单ID

    wxpayservice: '', //微信支付手续费
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    // console.log(options);
    let that = this;
    that.setData({
      id: Number(options.id),
      all_scribe_price: Number(options.all_scribe_price),
      all_price: Number(options.all_price),
      gang_name: options.gang_name,
      logistics_mode: Number(options.logistics_mode),
      head_phone: options.head_phone,
      user_name: options.user_name,
      expected_arrival_time: options.expected_arrival_time,
      shopcart: wx.getStorageSync('shopcart')
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    let that = this;
    // 获取自取点列表
    if (that.data.logistics_mode == 1 || that.data.logistics_mode == 2) {
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Gang_point,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        data: {
          id: that.data.id
        },
        method: 'POST',
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              ziquAddress: res.data.data,
            })
            if(res.data.data.length!=0){
              that.setData({
                editFormPhone:res.data.data[0].phone,
              })
            }
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
    // 获取收货地址列表
    if (that.data.logistics_mode == 2) {
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Address_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              peisongAddress: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 切换tab
  switchTab(e) {
    console.log(e);
    this.setData({
      tabType: e.currentTarget.dataset.type
    })
  },
  // 打开收货地址弹出层
  openReceiptPlace() {
    this.setData({
      showReceiptPlace: true,
      showBottomBar: false
    })
  },
  // 关闭收货地址弹出层
  closeReceiptPlace() {
    this.setData({
      showReceiptPlace: false,
      showBottomBar: true
    })
  },
  // 打开自取点弹出层
  openSelfMention() {
    this.setData({
      showSelfMention: true,
      showBottomBar: false
    })
  },
  // 关闭自取点弹出层
  closeSelfMention() {
    this.setData({
      showSelfMention: false,
      showBottomBar: true
    })
  },
  // 修改地址
  submitEdit() {
    // 物流提交
    if(this.data.tabType=='wuliu'){
      this.openPayTypePicker()
    }else{
      let that = this;
  
      if (that.data.editFormPhone == '') {
        wx.showToast({
          title: '手机号未录入',
          icon: 'none', 
          mask: true
        })
        return
      }
      wx.request({
        url: api.Gang_point_edit,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          id: that.data.ziquAddress[that.data.ziquIndex].id,
          name: that.data.ziquAddress[that.data.ziquIndex].name,
          address: that.data.ziquAddress[that.data.ziquIndex].address,
          remarks: that.data.ziquAddress[that.data.ziquIndex].remarks,
          phone: that.data.editFormPhone
        },
        success(res) {
          console.log(res);
          wx.hideLoading()
          if (res.data.code === 1) {
            console.log('修改手机号成功')
            that.openPayTypePicker()
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  },
  // 下单
  openPayTypePicker() {
    let that = this;
    // 第一次下单
    if (that.data.order_id == 0) {
      let logistics_mode = 0; //收货方式
      if (that.data.logistics_mode == 1) { //只有自取
        logistics_mode = 1;
      }
      if (that.data.logistics_mode == 2) {
        if (that.data.tabType == 'wuliu') {
          logistics_mode = 0;
        } else if (that.data.tabType == 'ziqu') {
          logistics_mode = 1;
        }
      }
      // 商品列表处理
      let arr = that.data.shopcart;
      for (let i = 0; i < arr.length; i++) {
        if (arr[i].type == 'guige') {
          let guige_index = arr[i].guige_index; //当前规格索引
          let specifications = [];
          specifications.push(arr[i].specifications[guige_index]); //当前规格
          arr[i].commodity_number = arr[i].count; //商品数量
          arr[i].commodity_price = arr[i].specifications[guige_index].price; //商品价格
          arr[i].specifications = specifications; //商品规格
          delete arr[i].price;
          delete arr[i].scribe_price;
          delete arr[i].sold;
          delete arr[i].stock;
          delete arr[i].purchase_restrictions_second;
          delete arr[i].step_price;
          delete arr[i].count;
          delete arr[i].type;
          delete arr[i].guige_index;
        } else if (arr[i].type == 'step') {
          let step_index = arr[i].step_index; //当前阶梯价索引
          let step_price = [];
          step_price.push(arr[i].step_price[step_index]); //当前阶梯价
          arr[i].commodity_number = arr[i].count; //商品数量
          arr[i].commodity_price = arr[i].step_price[step_index].price; //商品价格
          arr[i].step_price = step_price; //商品阶梯价
          delete arr[i].price;
          delete arr[i].scribe_price;
          delete arr[i].sold;
          delete arr[i].stock;
          delete arr[i].purchase_restrictions_second;
          delete arr[i].count;
          delete arr[i].type;
          delete arr[i].step_index;
          delete arr[i].specifications;
        }
      }
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      let discount = that.data.all_scribe_price - that.data.all_price;
      if (discount < 0) {
        discount = -discount;
      }
      if (logistics_mode == 0) {
        wx.request({
          url: api.Order_add,
          header: {
            'Authorization': wx.getStorageSync('token')
          },
          data: {
            id: that.data.id,
            logistics_mode: logistics_mode,
            original_price: that.data.all_scribe_price,
            discount: discount,
            payment_amount: that.data.all_price,
            remarks: that.data.remarks,
            commodity_list: arr,
            consignee: that.data.peisongAddress[that.data.peisongIndex].receiving_name,
            phone: that.data.editFormPhone,
            receiving_address: that.data.peisongAddress[that.data.peisongIndex].receiving_address
          },
          method: 'POST',
          success(res) {
            wx.hideLoading()
            console.log(res);
            if (res.data.code === 1) {
              let order_id = res.data.data;
              that.setData({
                order_id
              })
              that.getOrder_payment_method(order_id);
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail(err) {
            wx.hideLoading()
            wx.showToast({
              title: '发起网络请求失败',
              icon: 'none',
              mask: true
            })
          },
          complete() {
            // wx.hideLoading()
          }
        })
      } else if (logistics_mode == 1) {
        wx.request({
          url: api.Order_add,
          header: {
            'Authorization': wx.getStorageSync('token')
          },
          data: {
            id: that.data.id,
            logistics_mode: logistics_mode,
            original_price: that.data.all_scribe_price,
            discount: that.data.all_scribe_price - that.data.all_price,
            payment_amount: that.data.all_price,
            // remarks: that.data.remarks,  备注改成预留手机号 暂且注释
            commodity_list: arr,
            self_access_point: that.data.ziquAddress[that.data.ziquIndex].address,
            point_remarks: that.data.ziquAddress[that.data.ziquIndex].remarks,
            reserved_phone: that.data.remarks
          },
          method: 'POST',
          success(res) {
            wx.hideLoading()
            console.log(res);
            if (res.data.code === 1) {
              let order_id = res.data.data;
              that.setData({
                order_id
              })
              that.getOrder_payment_method(order_id);
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail(err) {
            wx.hideLoading()
            wx.showToast({
              title: '发起网络请求失败',
              icon: 'none',
              mask: true
            })
          },
          complete() {
            // wx.hideLoading()
          }
        })
      }
    } else {
      // 重复点击下单
      let order_id = Number(that.data.order_id);
      that.getOrder_payment_method(order_id);
    }
  },
  // 获取用户支付方式
  getOrder_payment_method(order_id) {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Order_payment_method,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: Number(order_id)
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            payTypes: res.data.data,
            showPayTypePicker: true,
            showBottomBar: false
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 关闭支付方式弹出层
  closePayTypePicker() {
    this.setData({
      showPayTypePicker: false,
      showBottomBar: true
    })
  },
  // 支付方式改变
  payTypeChanged(e) {
    let that = this;
    that.setData({
      payType: e.detail.value
    })
    // if(that.data.payTypes[that.data.payType[0]].payment_name == '微信支付') {
    //   let all_price = that.data.all_price;
    //   all_price = all_price * (1 + that.data.wxpayservice);
    //   all_price = all_price.toFixed(2);
    //   that.setData({
    //     all_price
    //   })
    // }
  },
  // 打开EMT支付弹出层
  openEMTPopup() {
    this.setData({
      showPayTypePicker: false,
      showEMTPopup: true,
      showBottomBar: false
    })
  },
  // 关闭EMT支付弹出层
  closeEMTPopup() {
    this.setData({
      showEMTPopup: false,
      showBottomBar: true
    })
  },
  // 确认支付
  confirmPay() {
    let that = this;
    let payType = that.data.payTypes[that.data.payType[0]];
    let id = that.data.order_id; //订单ID
    let payment_method = payType.payment_method; //支付方式（0微信支付，1EMT支付，2线下支付）
    let payment_price = that.data.all_price; //支付金额
    // 如果支付方式为微信支付-获取微信支付手续费
    if (payType.payment_name == '微信支付') {
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Service,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success(res) {
          wx.hideLoading();
          // console.log(res);
          that.setData({
            wxpayservice: Number(res.data.data)
          })
          payment_price = payment_price * (1 + that.data.wxpayservice);
          payment_price = payment_price.toFixed(2);
          that.zhenDePay(id, payment_method, payment_price);
        },
        fail(err) {
          wx.hideLoading()
        }
      })
    }else{
      that.zhenDePay(id, payment_method, payment_price);
    }
  },
  // 真的要支付吗？在这里？就现在？
  zhenDePay(id, payment_method, payment_price) {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Order_payment,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: Number(id),
        payment_method: Number(payment_method),
        payment_price: payment_price
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          if (res.data.msg == 'EMT支付') {
            that.setData({
              head_email: res.data.data.email,
              order_number: res.data.data.order_number
            })
            that.openEMTPopup()
          }
          if (res.data.msg == '线下支付') {
            that.setData({
              showPayTypePicker: false,
              showBottomBar: true
            })
            wx.navigateTo({
              url: '/pages/orderdetail/orderdetail?id=' + id,
            })
          }
          if (res.data.msg == '微信支付') {
            wx.requestPayment({
              appId: res.data.data.payParams.appId,
              nonceStr: res.data.data.payParams.nonceStr,
              package: res.data.data.payParams.package,
              paySign: res.data.data.payParams.paySign,
              timeStamp: res.data.data.payParams.timeStamp,
              signType: res.data.data.payParams.signType,
              success(res) {
                wx.hideLoading()
                console.log(res);
                wx.showToast({
                  title: '支付成功',
                  mask: true,
                  success() {
                    setTimeout(() => {
                      that.setData({
                        showPayTypePicker: false,
                        showBottomBar: true
                      })
                      wx.navigateTo({
                        url: '/pages/orderdetail/orderdetail?id=' + id,
                      })
                    }, 1500)
                  }
                })
              },
              fail(res) {
                wx.hideLoading()
                console.log(res);
                if (res.errMsg.search('cancel')) {
                  wx.showToast({
                    title: '用户取消支付',
                    icon: 'error',
                    mask: true
                  })
                } else if (res.errMsg.search('offline')) {
                  wx.showToast({
                    title: '网络断开连接',
                    icon: 'error',
                    mask: true
                  })
                }
              }
            })
          }
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 打开下单成功弹窗
  openOrderSuccessfulPopup() {
    this.setData({
      showOrderSuccessful: true
    })
  },
  // 关闭下单成功弹窗
  closeOrderSuccessfulPopup() {
    this.setData({
      showOrderSuccessful: false
    })
  },
  // 输入备注
  inputRemarks(e) {
    this.setData({
      remarks: e.detail.value
    })
  },
  inputRemarksPhone(e) {
    this.setData({
      editFormPhone: e.detail.value
    })
  },
  // 选择配送地址
  choosePeisongAddress(e) {
    this.setData({
      peisongIndex: e.currentTarget.dataset.index,
      showReceiptPlace: false,
      showBottomBar: true
    })
  },
  // 选择自取地址
  chooseZiquAddress(e) {
    this.setData({
      ziquIndex: e.currentTarget.dataset.index,
      showSelfMention: false,
      showBottomBar: true,
      editFormPhone:this.data.ziquAddress[e.currentTarget.dataset.index].phone
    })
  },
  // 联系团长
  callHead() {
    let that = this;
    wx.makePhoneCall({
      phoneNumber: that.data.head_phone,
    })
  },
  // 复制团长邮箱
  copyHeadEmail() {
    wx.setClipboardData({
      data: this.data.head_email,
    })
  },
  // 复制订单号
  copyOrderNumber() {
    wx.setClipboardData({
      data: this.data.order_number,
    })
  },
  // EMT已支付
  EMTpaid() {
    let id = this.data.order_id; //订单ID
    wx.navigateTo({
      url: '/pages/orderdetail/orderdetail?id=' + id,
    })
  },
  // 新增收货地址
  addAddress() {
    wx.navigateTo({
      url: '/pages/addaddress/addaddress?type=add',
    })
  },
  // 编辑收货地点
  editAddress(e) {
    let index = e.currentTarget.dataset.index
    // console.log(e.currentTarget.dataset.index);
    let address = this.data.peisongAddress[index];
    wx.setStorageSync('address', address);
    wx.navigateTo({
      url: '/pages/addaddress/addaddress?type=edit',
    })
  },
  // 获取微信支付手续费
  getWXPayServiceCharge() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Service,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        that.setData({
          wxpayservice: res.data.data
        })
      },
      fail(err) {
        wx.hideLoading()
      }
    })
  },
})