// pages/confirmrefund/confirmrefund.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '退款申请', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    id: 0, //订单id
    billdata: {},
    show: false,
    refund_reason: '', //退款原因
    refund_voucher: '', //凭证
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.setData({
      id: Number(options.id)
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.ReturnGoods_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            billdata: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 撤销退款
  cheXiaoApply() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Order_refund_revoke,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          wx.showToast({
            title: '操作成功',
            mask: true,
            success() {
              setTimeout(() => {
                wx.reLaunch({
                  url: '/pages/index/index',
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  copy() {
    wx.setClipboardData({
      data: this.data.billdata.refund_number,
    })
  },
  callHead() {
    wx.makePhoneCall({
      phoneNumber: this.data.billdata.phone,
    })
  },
  // 修改申请
  modifyApply() {
    this.setData({
      show: true
    })
  },
  onClose() {
    this.setData({
      show: false
    })
  },
  // 输入退款原因
  inputReason(e) {
    this.setData({
      refund_reason: e.detail.value
    })
  },
  // 上传退款凭证
  uploadVoucher() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        wx.chooseMedia({
          count: 1,
          mediaType: ['image'],
          success: (img) => {
            console.log(img);
            let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
            wx.showLoading({
              title: '文件上传中',
              mask: true
            })
            wx.uploadFile({
              filePath: img.tempFiles[0].tempFilePath,
              name: 'file',
              url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
              formData: {
                key: key,
                policy: oss.data.data.policy, // 输入你获取的的policy
                OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                signature: oss.data.data.Signature, // 输入你获取的的signature
              },
              success: (res) => {
                if (res.statusCode == 200) {
                  let src = 'https://' + oss.data.data.host + '/' + key;
                  that.setData({
                    refund_voucher: src
                  })
                }
              },
              fail: (err) => {
                console.log(err);
              },
              complete: () => {
                wx.hideLoading()
              }
            })
          },
          fail: (err) => {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 确认修改
  confirmModify() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Order_edit_refund,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.billdata.id,
        refund_reason: that.data.refund_reason,
        refund_voucher: that.data.refund_voucher
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '修改成功',
            mask: true,
            success() {
              setTimeout(()=>{
                wx.reLaunch({
                  url: '/pages/index/index',
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  }
})