// pages/copypastgroup/copypastgroup.js
const app = getApp();
const api = require('../../api/api');
// import pintuanData from '../../mocks/pintuan';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '复制往期拼团', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    tabs: [
      "全部", "未发布", "已发布", "已截团"
    ],
    zhong: 0, //当前tab索引
    radio: 1,
    icon: {
      normal: '../../images/unchecked.png',
      active: '../../images/checked.png',
    },
    pintuan: [],
    time: -1, //防抖时间
    goodName: '', //拼团名称
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    // that.setData({
    //   pintuan: pintuanData
    // })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    let that = this;
    that.getData();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  tabsbind(e) {
    this.setData({
      zhong: e.currentTarget.dataset.id
    })
    this.getData()
  },
  onChange(event) {
    this.setData({
      radio: event.detail,
    })
  },
  copyPinTuan() {
    let that = this;
    if (that.data.pintuan.length != 0) {
      let id = that.data.radio;
      wx.navigateTo({
        url: '/pages/announce/announce?type=copy&id=' + id,
      })
    }else {
      wx.showToast({
        title: '暂无往期拼团',
        icon: 'error',
        mask: true
      })
    }
  },
    // 搜索拼团名称
    searchGood(e) {
      let that = this;
      that.setData({
        goodName: e.detail.value
      })
      // 清除定时器
      clearTimeout(that.data.time);
      // 开启定时器
      that.data.time = setTimeout(() => {
        that.getData()
      }, 500)
    },
    // 获取数据
    getData() {
      let that = this;
      // 获取团长拼团列表
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.list_info,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        data: {
          id: wx.getStorageSync('userinfo').id,
          gang_name: that.data.goodName,
          status: that.data.zhong
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              pintuan: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    },
})