// pages/corporatebanktransfer/corporatebanktransfer.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '申请提现', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    arealength: 0,
    imageList: [], //图片列表
    /**表单 */
    name: '', //申请人姓名
    name_id: '', //申请人ID
    phone: '', //申请人手机号
    address: '', //申请人地址
    email: '', //申请人邮箱
    email_status: 0, //收据是否发送到邮箱（0否，1是）
    withdrawal_method: 0, //提现方式（0公司转账，1个人转账，2EMT,3联系客服）
    amount: 0, //提现金额
    industry: '', //行业（当提现方式为0和1传值）
    company_check: '', //银行支票（当提现方式为0传值）
    business_license: '', //营业执照（当提现方式为0传值）
    personal_check: '', //个人支票（当提现方式为1传值）
    driving_license: '', //驾照（当提现方式为1传值）
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    // console.log(options);
    this.setData({
      withdrawal_method: Number(options.withdrawal_method),
      amount: Number(options.balance)
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 输入申请人姓名
  inputName(e) {
    this.setData({
      name: e.detail.value
    })
  },
  // 输入申请人ID
  inputNameID(e) {
    this.setData({
      name_id: e.detail.value
    })
  },
  // 输入电话
  inputPhone(e) {
    this.setData({
      phone: e.detail.value
    })
  },
  // 输入地址
  inputAddress(e) {
    this.setData({
      arealength: e.detail.value.length,
      address: e.detail.value
    })
  },
  // 上传驾照图片
  uploadDrivingLicense() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        if (oss.statusCode === 200) {
          wx.chooseMedia({
            count: 1,
            mediaType: ['image'],
            success: (img) => {
              console.log(img);
              let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
              wx.showLoading({
                title: '文件上传中',
                mask: true
              })
              wx.uploadFile({
                filePath: img.tempFiles[0].tempFilePath,
                name: 'file',
                url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
                formData: {
                  key: key,
                  policy: oss.data.data.policy, // 输入你获取的的policy
                  OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                  success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                  signature: oss.data.data.Signature, // 输入你获取的的signature
                },
                success: (res) => {
                  if (res.statusCode == 200) {
                    let src = 'https://' + oss.data.data.host + '/' + key;
                    // console.log(src);
                    that.setData({
                      driving_license: src
                    })
                  }
                },
                fail: (err) => {
                  console.log(err);
                },
                complete: () => {
                  wx.hideLoading()
                }
              })
            },
            fail: (err) => {
              wx.hideLoading()
            }
          })
        } else {
          wx.showToast({
            title: '服务器出现错误',
            icon: 'none'
          })
        }
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 选择行业
  selectIndustry() {
    wx.navigateTo({
      url: '/pages/treadsel/treadsel',
    })
  },
  // 上传空支票
  uploadCompanyCheck() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        if (oss.statusCode === 200) {
          wx.chooseMedia({
            count: 1,
            mediaType: ['image'],
            success: (img) => {
              console.log(img);
              let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
              wx.showLoading({
                title: '文件上传中',
                mask: true
              })
              wx.uploadFile({
                filePath: img.tempFiles[0].tempFilePath,
                name: 'file',
                url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
                formData: {
                  key: key,
                  policy: oss.data.data.policy, // 输入你获取的的policy
                  OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                  success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                  signature: oss.data.data.Signature, // 输入你获取的的signature
                },
                success: (res) => {
                  if (res.statusCode == 200) {
                    let src = 'https://' + oss.data.data.host + '/' + key;
                    // console.log(src);
                    that.setData({
                      company_check: src
                    })
                  }
                },
                fail: (err) => {
                  console.log(err);
                },
                complete: () => {
                  wx.hideLoading()
                }
              })
            },
            fail: (err) => {
              wx.hideLoading()
            }
          })
        } else {
          wx.showToast({
            title: '服务器出现错误',
            icon: 'none'
          })
        }
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 上传营业执照
  uploadBusinessLicense() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        if (oss.statusCode === 200) {
          wx.chooseMedia({
            count: 1,
            mediaType: ['image'],
            success: (img) => {
              console.log(img);
              let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
              wx.showLoading({
                title: '文件上传中',
                mask: true
              })
              wx.uploadFile({
                filePath: img.tempFiles[0].tempFilePath,
                name: 'file',
                url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
                formData: {
                  key: key,
                  policy: oss.data.data.policy, // 输入你获取的的policy
                  OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                  success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                  signature: oss.data.data.Signature, // 输入你获取的的signature
                },
                success: (res) => {
                  if (res.statusCode == 200) {
                    let src = 'https://' + oss.data.data.host + '/' + key;
                    // console.log(src);
                    that.setData({
                      business_license: src
                    })
                  }
                },
                fail: (err) => {
                  console.log(err);
                },
                complete: () => {
                  wx.hideLoading()
                }
              })
            },
            fail: (err) => {
              wx.hideLoading()
            }
          })
        } else {
          wx.showToast({
            title: '服务器出现错误',
            icon: 'none'
          })
        }
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 上传个人银行账户空支票
  uploadPersonalCheck() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        if (oss.statusCode === 200) {
          wx.chooseMedia({
            count: 1,
            mediaType: ['image'],
            success: (img) => {
              console.log(img);
              let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
              wx.showLoading({
                title: '文件上传中',
                mask: true
              })
              wx.uploadFile({
                filePath: img.tempFiles[0].tempFilePath,
                name: 'file',
                url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
                formData: {
                  key: key,
                  policy: oss.data.data.policy, // 输入你获取的的policy
                  OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                  success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                  signature: oss.data.data.Signature, // 输入你获取的的signature
                },
                success: (res) => {
                  if (res.statusCode == 200) {
                    let src = 'https://' + oss.data.data.host + '/' + key;
                    // console.log(src);
                    that.setData({
                      personal_check: src
                    })
                  }
                },
                fail: (err) => {
                  console.log(err);
                },
                complete: () => {
                  wx.hideLoading()
                }
              })
            },
            fail: (err) => {
              wx.hideLoading()
            }
          })
        } else {
          wx.showToast({
            title: '服务器出现错误',
            icon: 'none'
          })
        }
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 收据是否发送到邮箱
  changeEmailStatus(e) {
    this.setData({
      email_status: e.detail
    })
  },
  // 输入邮箱
  inputEmail(e) {
    this.setData({
      email: e.detail.value
    })
  },
  // 提交申请-公司转账
  submitCompany() {
    let that = this;
    if (that.data.name == '') {
      wx.showToast({
        title: '申请人姓名未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.name_id == '') {
      wx.showToast({
        title: '申请人ID未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.phone == '') {
      wx.showToast({
        title: '电话未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.address == '') {
      wx.showToast({
        title: '地址未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.industry == '') {
      wx.showToast({
        title: '行业未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.company_check == '') {
      wx.showToast({
        title: '公司银行账号空支票未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.business_license == '') {
      wx.showToast({
        title: '营业执照未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.email_status == 1 && that.data.email == '') {
      wx.showToast({
        title: '邮箱未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Withdrawalmanagement_apply,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        name: that.data.name,
        name_id: that.data.name_id,
        phone: that.data.phone,
        address: that.data.address,
        industry: that.data.industry,
        company_check: that.data.company_check,
        business_license: that.data.business_license,
        email_status: that.data.email_status,
        email: that.data.email,
        withdrawal_method: that.data.withdrawal_method,
        amount: that.data.amount
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          let id = res.data.data;
          wx.showToast({
            title: '提交成功',
            icon: 'success',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateTo({
                  url: '/pages/company/company?type=apply&id=' + id,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 提交申请-个人转账
  submitPersonal() {
    let that = this;
    if (that.data.name == '') {
      wx.showToast({
        title: '申请人姓名未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.name_id == '') {
      wx.showToast({
        title: '申请人ID未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.phone == '') {
      wx.showToast({
        title: '电话未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.address == '') {
      wx.showToast({
        title: '地址未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.driving_license == '') {
      wx.showToast({
        title: '驾照图片未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.industry == '') {
      wx.showToast({
        title: '行业未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.personal_check == '') {
      wx.showToast({
        title: '个人银行账号空支票未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.email_status == 1 && that.data.email == '') {
      wx.showToast({
        title: '邮箱未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Withdrawalmanagement_apply,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        name: that.data.name,
        name_id: that.data.name_id,
        phone: that.data.phone,
        address: that.data.address,
        driving_license: that.data.driving_license,
        industry: that.data.industry,
        personal_check: that.data.personal_check,
        email_status: that.data.email_status,
        email: that.data.email,
        withdrawal_method: that.data.withdrawal_method,
        amount: that.data.amount
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          let id = res.data.data;
          wx.showToast({
            title: '提交成功',
            icon: 'success',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateTo({
                  url: '/pages/company/company?type=apply&id=' + id,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 提交申请-EMT
  submitEMT() {
    let that = this;
    if (that.data.name == '') {
      wx.showToast({
        title: '申请人姓名未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.name_id == '') {
      wx.showToast({
        title: '申请人ID未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.phone == '') {
      wx.showToast({
        title: '电话未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.address == '') {
      wx.showToast({
        title: '地址未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.email_status == 1 && that.data.email == '') {
      wx.showToast({
        title: '邮箱未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Withdrawalmanagement_apply,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        name: that.data.name,
        name_id: that.data.name_id,
        phone: that.data.phone,
        address: that.data.address,
        email_status: that.data.email_status,
        email: that.data.email,
        withdrawal_method: that.data.withdrawal_method,
        amount: that.data.amount
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          let id = res.data.data;
          wx.showToast({
            title: '提交成功',
            icon: 'success',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateTo({
                  url: '/pages/company/company?type=apply&id=' + id,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
})