// pages/deliveryaddress/deliveryaddress.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '提货点管理', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    type: 0, //进入类型（0：提货；1：交货）
    addressList: [], //收货地址列表
    tihuoList: [], //提货地址列表
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    let type = Number(options.type);
    if (type === 0) {
      that.setData({
        navbarData: {
          showCapsule: 1,
          title: '提货点管理',
          capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
        },
        type: type
      })
    } else if (type === 1) {
      that.setData({
        navbarData: {
          showCapsule: 1,
          title: '收货地址',
          capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
        },
        type: type
      })
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    if (that.data.type === 0) {
      // 提货点列表
      wx.request({
        url: api.Gang_point,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              tihuoList: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    } else if (that.data.type === 1) {
      wx.request({
        url: api.Address_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              addressList: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 新增提货地点
  addDeliveryAddress() {
    // console.log('新增提货地点');
    wx.navigateTo({
      url: '/pages/adddeliveryaddress/adddeliveryaddress?type=add',
    })
  },
  // 编辑提货地点
  editDeliveryAddress(e) {
    let index = e.currentTarget.dataset.index;
    let address = this.data.tihuoList[index];
    wx.setStorageSync('address', address);
    wx.navigateTo({
      url: '/pages/adddeliveryaddress/adddeliveryaddress?type=edit',
    })
  },
  // 新增收货地点
  addReceiptAddress() {
    // console.log('新增收货地点');
    wx.navigateTo({
      url: '/pages/addaddress/addaddress?type=add',
    })
  },
  // 编辑收货地点
  editAddress(e) {
    let index = e.currentTarget.dataset.index
    // console.log(e.currentTarget.dataset.index);
    let address = this.data.addressList[index];
    wx.setStorageSync('address', address);
    wx.navigateTo({
      url: '/pages/addaddress/addaddress?type=edit',
    })
  }
})