// pages/exportorder/exportorder.js
const app = getApp();
const api = require('../../api/api');
const moment = require('../../utils/moment.min.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '导出订单', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    order_status: [
      '全部',
      '待支付',
      '待取货',
      '交易完成',
      '已取消',
      '退款申请'
    ],
    statusIndex: 0,
    startdate: '2021-02-21',
    enddate: '2021-04-21',
    order_number: 0, //订单数
    url: '', //导出地址
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.getDate()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  getDate() {
    let that = this;
    let startDate = moment().subtract(30, "days").format("YYYY-MM-DD");
    let endDate = moment().format('YYYY-MM-DD');
    that.setData({
      startdate: startDate,
      enddate: endDate
    })
    that.getOrderManagementExport()
  },
  getOrderManagementExport() {
    let that = this;
    if (that.data.statusIndex === 0) {
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.OrderManagement_export,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          order_time: that.data.startdate,
          end_time: that.data.enddate
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              order_number: res.data.data.order_number,
              url: res.data.data.url
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    } else {
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.OrderManagement_export,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          order_status: Number(that.data.statusIndex) - 1,
          order_time: that.data.startdate,
          end_time: that.data.enddate
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              order_number: res.data.data.order_number,
              url: res.data.data.url
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    }
  },
  // 切换订单状态
  statusChange(e) {
    this.setData({
      statusIndex: Number(e.detail.value)
    })
    this.getOrderManagementExport()
  },
  // 跳转到订单详情
  navToExportOrderDetail() {
    let statusIndex = this.data.statusIndex;
    let startdate = this.data.startdate;
    let enddate = this.data.enddate;
    let order_number = this.data.order_number;
    let url = this.data.url;
    wx.navigateTo({
      url: '/pages/exportorderdetail/exportorderdetail?statusIndex=' + statusIndex + '&startdate=' + startdate + '&enddate=' + enddate + '&order_number=' + order_number + '&url=' + url
    })
  },
  // 开始日期改变
  changeStartDate(e) {
    let that = this;
    let result = moment(e.detail.value).isSameOrBefore(that.data.enddate);
    if (result == true) {
      that.setData({
        startdate: e.detail.value
      })
    } else {
      wx.showToast({
        title: '开始日期必须在结束日期之前',
        icon: 'none',
        mask: true
      })
    }
  },
  // 结束日期改变
  changeEndDate(e) {
    let that = this;
    let result = moment(e.detail.value).isSameOrAfter(that.data.startdate);
    if (result == true) {
      that.setData({
        enddate: e.detail.value
      })
    } else {
      wx.showToast({
        title: '结束日期必须在开始日期之后',
        icon: 'none',
        mask: true
      })
    }
  },
})