// pages/exportorderdetail/exportorderdetail.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '导出订单', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    /* 组件参数 */
    showPopup: false,
    order_status: [
      '全部',
      '待支付',
      '待取货',
      '交易完成',
      '已取消',
      '退款申请'
    ],
    statusIndex: 0,
    startdate: '2021-02-21',
    enddate: '2021-04-21',
    order_number: 0, //订单数
    url: '', //导出地址
    email: '', //邮箱
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.setData({
      statusIndex: options.statusIndex,
      startdate: options.startdate,
      enddate: options.enddate,
      order_number: options.order_number,
      url: options.url
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 打开弹出层
  openPopup() {
    this.setData({
      showPopup: true
    })
  },
  // 关闭弹出层
  closePopup() {
    this.setData({
      showPopup: false
    })
  },
  // 直接打开Excel
  openFile() {
    let that = this;
    let time = Date.now();
    wx.downloadFile({
      url: 'https://' + that.data.url,
      filePath: wx.env.USER_DATA_PATH + '/' + time + '.xlsx',
      success(res) {
        const filePath = res.filePath;
        wx.openDocument({
          filePath: filePath,
          showMenu: true,
          fileType: 'xlsx',
          success(res) {
            console.log('打开文档成功', res);
          }
        })
      },
      fail(err) {
        console.log(err);
      }
    })
  },
  inputEmail(e) {
    this.setData({
      email: e.detail.value
    })
  },
  // 确认弹出层
  confirmPopup() {
    let that = this;
    if(that.data.email == '') {
      wx.showToast({
        title: '邮箱未录入',
        mask: true,
        icon: 'none'
      })
      return
    }
    wx.showLoading({
      title: '发送中',
      mask: true
    })
    wx.request({
      url: api.email,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        email: that.data.email,
        url: that.data.url
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '发送成功',
            mask: true,
            success() {
              setTimeout(() => {
                that.setData({
                  showPopup: false
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  copyURL() {
    wx.setClipboardData({
      data: this.data.url
    })
  }
})