// pages/goodsbank/goodsbank.js
const app = getApp();
const api = require('../../api/api');
const storageManager = require("../../utils/storage-manager.js");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '商品库', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    time: -1, //防抖时间
    goodName: '', //搜索商品名
    openManageMode: false, //是否开启管理模式
    checkBoxResult: [], //复选框结果
    checkedAll: false,
    openAllCategory: false, //是否开启全部分类
    sidetabs: [{
        name: '全部',
        headimg: '',
        seller_id: null
      },
      {
        name: '我的商品',
        img_url: '',
        seller_id: wx.getStorageSync('userinfo').id
      }
    ], //侧边分类
    sideindex: 0, //侧边分类索引
    showCategory: false, //分类弹出层显示
    categorys: [{
      id: null,
      classification_name: '全部',
      checked: false
    }], //分类
    categoryIndex: 0, //当前选中分类
    settingCategoryIndex: 0, //设置选择分类
    goods: [], //商品
    swiperList: [
      'https://s1.ax1x.com/2022/04/27/LqmgpV.png',
      'https://s1.ax1x.com/2022/04/27/Lqm2lT.png',
      'https://s1.ax1x.com/2022/04/27/LqmgpV.png',
      'https://s1.ax1x.com/2022/04/27/Lqm2lT.png'
    ],
    guiges: ['500g', '1kg'],
    guigeIndex: 0,
    showGoodDetail: false, //显示商品详情
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // 商品分类
    new Promise((resolve, reject) => {
      wx.request({
        url: api.Classification_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success: (res) => {
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data;
            for (let i = 0; i < arr.length; i++) {
              arr[i].checked = false;
            }
            let categorys = that.data.categorys;
            categorys = categorys.concat(arr);
            that.setData({
              categorys
            })
            resolve(res);
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail: (err) => {
          reject(err)
        }
      })
    }).then(() => {
      // 团长列表
      new Promise((resolve, reject) => {
        wx.request({
          url: api.Commoditywarehouse_head,
          header: {
            'Authorization': wx.getStorageSync('token')
          },
          method: 'POST',
          success: (res) => {
            console.log(res);
            if (res.data.code === 1) {
              let sidetabs = that.data.sidetabs;
              sidetabs = sidetabs.concat(res.data.data);
              that.setData({
                sidetabs
              })
              resolve(res);
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail: (err) => {
            reject(err);
          }
        })
      }).then(() => {
        // 获取商品列表
        wx.request({
          url: api.Commoditywarehouse_list,
          header: {
            'Authorization': wx.getStorageSync('token')
          },
          method: 'POST',
          success: (res) => {
            console.log(res);
            if (res.data.code === 1) {
              let arr = res.data.data;
              for (let i = 0; i < arr.length; i++) {
                arr[i].xuan = false;
              }
              that.setData({
                goods: arr
              })
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail: (err) => {
            console.log(err);
          },
          complete: () => {
            wx.hideLoading()
          }
        })
      })
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 搜索商品
  searchGood(e) {
    let that = this;
    that.setData({
      goodName: e.detail.value
    })
    // 清除定时器
    clearTimeout(this.data.time);
    // 开启定时器
    this.data.time = setTimeout(() => {
      wx.showLoading({
        title: '搜索中',
        mask: true
      })
      wx.request({
        url: api.Commoditywarehouse_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          user_id: that.data.sidetabs[that.data.sideindex].seller_id,
          classification_id: that.data.categorys[that.data.categoryIndex].id,
          commodity_name: that.data.goodName
        },
        success: (res) => {
          console.log(res);
          if (res.data.code === 1) {
            let arr = res.data.data;
            for (let i = 0; i < arr.length; i++) {
              arr[i].xuan = false;
            }
            that.setData({
              goods: arr
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail: (err) => {
          console.log(err);
        },
        complete: () => {
          wx.hideLoading()
        }
      })
    }, 500)
  },
  // 添加新商品
  navToAddNewGood() {
    wx.navigateTo({
      url: '/pages/addtogood/addtogood',
    })
  },
  // 点击管理按钮
  clickManageBtn() {
    this.setData({
      openManageMode: !this.data.openManageMode,
      openAllCategory: false
    })
  },
  // 点击侧边栏
  sidetap(e) {
    let that = this;
    let index = e.currentTarget.dataset.index;
    let user_id = that.data.sidetabs[index].seller_id;
    let classification_id = that.data.categorys[that.data.categoryIndex].id;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // 获取商品列表
    wx.request({
      url: api.Commoditywarehouse_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        user_id: user_id,
        classification_id: classification_id
      },
      success: (res) => {
        console.log(res);
        if (res.data.code === 1) {
          let arr = res.data.data;
          for (let i = 0; i < arr.length; i++) {
            arr[i].xuan = false;
          }
          that.setData({
            goods: arr,
            sideindex: index
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail: (err) => {
        console.log(err);
      },
      complete: () => {
        wx.hideLoading()
      }
    })
  },
  // 打开全部分类菜单
  clickAllCategoryBtn() {
    this.setData({
      openAllCategory: true,
      openManageMode: false
    })
  },
  // 关闭全部分类菜单
  closeAllCategory() {
    this.setData({
      openAllCategory: false,
      openManageMode: false
    })
  },
  // 打开分类弹出层
  showCategoryPopup() {
    this.setData({
      showCategory: true
    })
  },
  // 关闭分类弹出层
  closeCategoryPopup() {
    this.setData({
      showCategory: false,
      settingCategoryIndex: 0
    })
  },
  // 单选分类
  chooseCategory(e) {
    let that = this;
    let index = e.currentTarget.dataset.index;
    let classification_id = that.data.categorys[index].id;
    let user_id = that.data.sidetabs[that.data.sideindex].seller_id;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // 获取商品列表
    wx.request({
      url: api.Commoditywarehouse_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        user_id: user_id,
        classification_id: classification_id
      },
      success: (res) => {
        console.log(res);
        if (res.data.code === 1) {
          let arr = res.data.data;
          for (let i = 0; i < arr.length; i++) {
            arr[i].xuan = false;
          }
          that.setData({
            goods: arr,
            categoryIndex: index
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail: (err) => {
        console.log(err);
      },
      complete: () => {
        wx.hideLoading()
      }
    })
  },
  // 多选分类
  selectCategory(e) {
    let index = e.currentTarget.dataset.index;
    // let categorys = this.data.categorys;
    // categorys[index].checked = !categorys[index].checked;
    // this.setData({
    //   categorys
    // })
    this.setData({
      settingCategoryIndex: index
    })
  },
  // 确认设置分类
  confirmSetCategory() {
    let that = this;
    let classification_id = that.data.categorys[that.data.settingCategoryIndex].id;
    let arr = that.data.checkBoxResult;
    for (let i = 0; i < arr.length; i++) {
      arr[i] = Number(arr[i]);
    }
    let commodity_id = arr;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Commoditywarehouse_edit,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        commodity_id: commodity_id,
        classification_id: classification_id
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '设置成功',
            mask: true,
            success() {
              setTimeout(() => {
                that.setData({
                  showCategory: false,
                  settingCategoryIndex: 0
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 复选框改变
  checkBoxChange(event) {
    let that = this;
    that.setData({
      checkBoxResult: event.detail,
    })
    const items = that.data.goods;
    const values = event.detail;
    for (let i = 0, lenI = items.length; i < lenI; ++i) {
      items[i].xuan = false
      for (let j = 0, lenJ = values.length; j < lenJ; ++j) {
        if (items[i].id == values[j]) {
          items[i].xuan = true
          break
        }
      }
    }
    that.setData({
      goods: items
    })
    if (event.detail.length == that.data.goods.length) {
      that.setData({
        checkedAll: true
      })
    } else {
      that.setData({
        checkedAll: false
      })
    }
  },
  // 全选复选框
  selectAll() {
    const items = this.data.goods;
    const checkBoxResult = [];
    for (let i = 0; i < items.length; i++) {
      items[i].xuan = true;
      checkBoxResult.push(items[i].id);
    }
    this.setData({
      goods: items,
      checkedAll: true,
      checkBoxResult: checkBoxResult
    })
  },
  // 取消全选
  cancleAll() {
    const items = this.data.goods;
    for (let i = 0; i < items.length; i++) {
      items[i].xuan = false
    }
    this.setData({
      goods: items,
      checkedAll: false,
      checkBoxResult: []
    })
  },
  // 编辑商品
  editGoods(e) {
    let index = e.currentTarget.dataset.index;
    console.log(index);
  },
  // 删除商品 
  deleteGoods() {
    // console.log(this.data.checkBoxResult);
  },
  // 打开商品详情
  openGoodDetail() {
    this.setData({
      showGoodDetail: true
    })
  },
  // 关闭商品详情
  closeGoodDetail() {
    this.setData({
      showGoodDetail: false
    })
  },
  // 添加到拼团
  async addToPintuan() {
    let that = this;
    let arr = [];
    for (let i = 0; i < that.data.checkBoxResult.length; i++) {
      let obj = that.data.goods.find(
        (item) => {
          return item.id == that.data.checkBoxResult[i];
        }
      )
      arr.push(obj);
    }
    await storageManager.set('subPageResult', arr);
    wx.navigateBack({
      delta: 1
    })
  }
})