// pages/goodverify/goodverify.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '订单核销', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    tabs: [
      "全部", "未收货", "已收货"
    ],
    tabIndex: 0, //当前tab索引
    orderwriteList: [], //订单核销列表
    time: -1, //防抖时间
    goodName: '', //订单号
    code_result: '', //扫码返回结果
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.getOrderwrite_list()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    let that = this;
    if (that.data.code_result != '') {
      wx.showLoading({
        title: '扫码成功',
        mask: true
      })
      wx.request({
        url: api.Orderwrite,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        data: {
          card_number: that.data.code_result,
          write_method: 0
        },
        method: 'POST',
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            wx.showToast({
              title: '核销成功',
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          that.setData({
            code_result: ''
          })
          // wx.hideLoading()
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 点击tab
  selectTab(e) {
    this.setData({
      tabIndex: e.currentTarget.dataset.index
    })
    this.getOrderwrite_list()
  },
  // 获取数据
  getOrderwrite_list() {
    let that = this;
    // 获取订单核销列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Orderwrite_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        order_status: that.data.tabIndex
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            orderwriteList: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 搜索订单号
  searchGood(e) {
    let that = this;
    that.setData({
      goodName: e.detail.value
    })
    if (that.data.goodName != '') {
      // 清除定时器
      clearTimeout(that.data.time);
      // 开启定时器
      that.data.time = setTimeout(() => {
        wx.showLoading({
          title: '搜索中',
          mask: true
        })
        wx.request({
          url: api.Orderwrite_list,
          header: {
            'Authorization': wx.getStorageSync('token')
          },
          data: {
            card_number: that.data.goodName,
            order_status: that.data.tabIndex
          },
          method: 'POST',
          success(res) {
            console.log(res);
            if (res.data.code === 1) {
              that.setData({
                orderwriteList: res.data.data
              })
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail(err) {
            wx.showToast({
              title: '发起网络请求失败',
              icon: 'none',
              mask: true
            })
          },
          complete() {
            wx.hideLoading()
          }
        })
      }, 500)
    } else {
      that.getOrderwrite_list()
    }
  },
  // 跳转卡券号核销
  navToCardVerify() {
    wx.navigateTo({
      url: '/pages/cardverify/cardverify',
    })
  },
  saoma() {
    wx.navigateTo({
      url: '/pages/verify/verify',
    })
  },
})