// pages/helptosell/helptosell.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '选品大厅', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    tabs: ['供应大厅', '关联供应商', '我的申请'],
    tabindex: 0,
    height: 0,
    biaoqians: [], //供应大厅-标签数组
    showbiaoqian: false, //显示供应大厅-标签
    lists: [],
    bqs: 0,
    wlist: [],
    wbqs: 0,
    supplyhall_list: [], //供应大厅列表
    supplyhall_supplier_list: [], //正在帮卖列表
    /* 我的申请 */
    shenqingindex: 0, //申请状态（0未审核，1已审核）
    gang_name: '', //团长姓名
    supplyhall_help_sell: [], //我的申请列表
    time: -1, //防抖时间
  },
  tabtap(e) {
    this.setData({
      tabindex: e.currentTarget.dataset.index
    })
  },
  shenq(e) {
    this.setData({
      shenqingindex: e.currentTarget.dataset.index
    })
    this.getSupplyhallHelpSell()
  },
  // 添加标签重置
  chongzhi() {
    let list = this.data.biaoqians
    for (let i = 0; i < list.length; i++) {
      list[i].xuan = 0
    }
    this.setData({
      biaoqians: list,
      lists: list,
      bqs: 0,
      showbiaoqian: false,
      wbqs: 0
    })
    this.getSupplyhallList()
    this.getSupplyhallSupplierList()
  },
  // 添加标签完成
  wancheng() {
    let that = this;
    that.setData({
      lists: that.data.wlist,
      bqs: that.data.wbqs,
      showbiaoqian: false
    })
    let classification_id = [];
    for (let i = 0; i < that.data.lists.length; i++) {
      if (that.data.lists[i].xuan === 1) {
        classification_id.push(that.data.lists[i].id)
      }
    }
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Supplyhall_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        classification_id: classification_id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            supplyhall_list: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    wx.request({
      url: api.Supplyhall_supplier_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: classification_id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            supplyhall_supplier_list: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 关闭添加标签弹窗
  closebiaoqian() {
    this.setData({
      showbiaoqian: false
    })
  },
  // 显示添加标签弹窗
  biaoqianshow() {
    this.setData({
      showbiaoqian: true
    })
  },
  // 选择标签
  xuan(e) {
    let list = this.data.biaoqians;
    let bqs = this.data.wbqs;
    let index = e.currentTarget.dataset.index;
    if (list[index].xuan == 0) {
      list[index].xuan = 1;
      bqs++;
    } else {
      list[index].xuan = 0;
      bqs--;
    };
    this.setData({
      biaoqians: list,
      wlist: list,
      wbqs: bqs
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      height: app.globalData.height
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    // 商品分类列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Classification_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          let arr = res.data.data;
          for (let i = 0; i < arr.length; i++) {
            arr[i].xuan = 0;
          }
          that.setData({
            biaoqians: arr
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    // 获取供应大厅列表
    that.getSupplyhallList()
    // 获取正在帮卖列表（关联供应商）
    that.getSupplyhallSupplierList()
    // 获取我的申请列表
    that.getSupplyhallHelpSell()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 获取供应大厅列表
  getSupplyhallList() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Supplyhall_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            supplyhall_list: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 获取关联供货商列表
  getSupplyhallSupplierList() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Supplyhall_supplier_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            supplyhall_supplier_list: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 输入拼团名称
  inputGangName(e) {
    let that = this;
    that.setData({
      gang_name: e.detail.value
    })
    // 清除定时器
    clearTimeout(that.data.time);
    // 开启定时器
    this.data.time = setTimeout(() => {
      that.getSupplyhallHelpSell()
    }, 500)
  },
  // 我的申请
  getSupplyhallHelpSell() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Supplyhall_help_sell,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        apply_status: Number(that.data.shenqingindex),
        gang_name: that.data.gang_name
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            supplyhall_help_sell: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 跳转来自供应大厅
  navFromGYDT(e) {
    // console.log(e);
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '/pages/tuanzdetail/tuanzdetail?type=0&id=' + id,
    })
  },
  // 跳转来自关联供应商
  navFromGLGYS(e) {
    // console.log(e);
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '/pages/tuanzdetail/tuanzdetail?type=1&id=' + id,
    })
  },
  // 跳转来自我的申请
  navFromWDSQ(e) {
    let id = e.currentTarget.dataset.id;
    let status = e.currentTarget.dataset.status;
    let uid = e.currentTarget.dataset.uid;
    wx.navigateTo({
      url: '/pages/myapplyfor/myapplyfor?id=' + id + '&status=' + status + '&uid=' + uid,
    })
  }
})