// index.js
// 获取应用实例
const app = getApp();
const api = require('../../api/api');

Page({
  data: {
    test: {
      name: "团长"
    },
    height: 0,
    tabs: [
      "订阅团长", "最近浏览", "我的订单"
    ],
    ordertabs: [
      "全部", "待支付", "待收货", "已完成", "退款/售后"
    ],
    orderindex: 0,
    zhong: 0, //当前tab索引
    dingyues: [], //订阅团长
    pintuan: [], //最近浏览
    orders: [], //我的订单

    showSearchPopup: false, //显示搜索弹窗
    keywords: '', //搜索关键字

    time: -1, //防抖时间
    goodName: '', //最近浏览搜索

    share_order_id: 0, //分享订单ID
  },
  onLoad(options) {
    let that = this;
    that.setData({
      height: app.globalData.height,
      enterType: Number(options.type)
    })
    // 获取我的订单列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Member_order,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            orders: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  onShow() {
    let that = this;
    // 获取订阅团长列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Head_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            dingyues: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    // 获取最近浏览列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.footprints,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            pintuan: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    // let order_id = this.data.share_order_id; //订单ID
    return {
      title: '优团小栈',
      // path: '/pages/orderdetail/orderdetail?id=' + order_id,
      // imageUrl: 'https://s4.ax1x.com/2021/12/29/TccgfK.jpg'
    }
  },
  // 标签页切换
  tabsbind(e) {
    this.setData({
      zhong: e.currentTarget.dataset.id
    })
  },
  // 订单标签切换
  ordertap(e) {
    let that = this;
    let oid = e.currentTarget.dataset.oid; //用户选中的标签
    let order_status = 0; //对应的订单状态
    if (oid === 0) {
      // 全部
      order_status = '';
    } else if (oid === 1) {
      // 待支付
      order_status = 0;
    } else if (oid === 2) {
      // 待取货
      order_status = 1;
    } else if (oid === 3) {
      // 已完成
      order_status = 2;
    } else if (oid === 4) {
      // 退款/售后
      order_status = 4;
    }
    if (oid === 0) {
      // 获取我的订单列表-全部
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Member_order,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              orders: res.data.data,
              orderindex: oid
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    } else {
      // 获取我的订单列表
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Member_order,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          order_status: order_status
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              orders: res.data.data,
              orderindex: oid
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    }
    // this.setData({
    //   orderindex: e.currentTarget.dataset.oid
    // })
  },
  // 输入最近浏览关键字
  inputGoodName(e) {
    let that = this;
    that.setData({
      goodName: e.detail.value
    })
    // 清除定时器
    clearTimeout(this.data.time);
    // 开启定时器
    this.data.time = setTimeout(() => {
      wx.showLoading({
        title: '搜索中',
        mask: true
      })
      wx.request({
        url: api.footprints,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          name: that.data.goodName
        },
        success: (res) => {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              pintuan: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail: (err) => {
          console.log(err);
        },
        complete: () => {
          wx.hideLoading()
        }
      })
    }, 500)
  },
  // 团长跳转
  navToTuanZhang(e) {
    let url = e.currentTarget.dataset.url;
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: url + '&id=' + id
    })
  },
  // 拼团跳转
  navToPinTuanDetail(e) {
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '/pages/pintuandetail/pintuandetail?type=dingyue&id=' + id,
    })
  },
  // 订单跳转
  navToOrderDetail(e) {
    let id = e.currentTarget.dataset.id;
    let order_status = e.currentTarget.dataset.status;
    // console.log(order_status);
    if(order_status == 4) {
      wx.navigateTo({
        url: '/pages/confirmrefund/confirmrefund?id=' + id,
      })
    }else {
      wx.navigateTo({
        url: '/pages/orderdetail/orderdetail?id=' + id,
      })
    }
  },
  // 打开搜索框
  openSearchPopup() {
    this.setData({
      showSearchPopup: true
    })
  },
  // 关闭搜索框
  clsoeSearchPopup() {
    this.setData({
      showSearchPopup: false
    })
  },
  // 输入关键字
  inputKeyWords(e) {
    this.setData({
      keywords: e.detail.value
    })
  },
  // 搜索
  searchKeyWords() {
    let that = this;
    if (that.data.keywords == '') {
      wx.showToast({
        title: '请输入搜索关键字',
        mask: true,
        icon: 'none'
      })
      return
    }
    that.setData({
      orderindex: 0
    })
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Member_order,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        gang_name: that.data.keywords
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            orders: res.data.data,
            showSearchPopup: false
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 分享订单
  shareOrder(e) {
    this.setData({
      share_order_id: e.detail.value
    })
  }
})