// pages/invitehelpmesell/invitehelpmesell.js
const app = getApp();
const api = require('../../api/api');
import tuanZhangData from '../../mocks/tuanZhang';
const storageManager = require("../../utils/storage-manager.js");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '发布帮卖', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    toptabindex: 0, //顶部标签索引
    /* 帮卖商品 */
    bodytab: ["关联供应商", "待审核", "提交申请"],
    bodytabindex: 0,
    foottab: [{
      id: 0,
      classification_name: '全部'
    }],
    leiindex: 0,
    checked: false,
    show: false,
    currentPriceIndex: 0,
    prices: [],
    openManageModeGood: false,
    mockDataGood: [], //假数据
    applyGoods: [], //提交申请商品
    checkBoxResultGood: [], //复选框结果
    checkedAllGood: false, //是否全选
    /* 卖货团长 */
    bodytab2: ["关联供应商", "待审核", "已审核"],
    bodytabindex2: 0,
    openManageMode: false,
    mockData: [], //假数据
    checkBoxResult: [], //复选框结果
    checkedAll: false, //是否全选
  },
  // 切换顶部tab
  toptab(e) {
    this.setData({
      toptabindex: e.currentTarget.dataset.index
    })
  },
  // 切换帮卖商品tab
  bodytab(e) {
    this.setData({
      bodytabindex: e.currentTarget.dataset.index,
      openManageModeGood: false,
      mockDataGood: [],
      checkBoxResultGood: [],
      checkedAllGood: false
    })
    if (this.data.bodytabindex === 0 || this.data.bodytabindex === 1) {
      this.getHelpsellList()
    } else {
      this.setData({
        mockDataGood: []
      })
    }
  },
  // 切换商品类型
  leixing(e) {
    this.setData({
      leiindex: e.currentTarget.dataset.index
    })
    this.getHelpsellList()
  },
  // 新增阶梯价行
  addbulk() {
    let bulk = {
      number: "",
      price: ""
    }
    let prices = this.data.prices;
    prices.push(bulk)
    this.setData({
      prices: prices
    })
  },
  // 删除阶梯价行
  delbulk(e) {
    let index = e.currentTarget.dataset.index
    let list = this.data.prices;
    list.splice(index, 1);
    this.setData({
      prices: list
    })
  },
  // 数字输入
  numinput(e) {
    let index = Number(e.currentTarget.dataset.index);
    let value = e.detail.value;
    let list = this.data.prices;
    list[index].number = value;
    this.setData({
      prices: list
    })
  },
  // 价格输入
  priceinput(e) {
    let index = Number(e.currentTarget.dataset.index);
    let value = e.detail.value;
    let list = this.data.prices;
    list[index].price = value;
    this.setData({
      prices: list
    })
  },
  // 开关改变
  changeIsItVisible(e) {
    console.log(e);
    let index = e.currentTarget.dataset.index;
    let value = e.detail;
    let mockDataGood = this.data.mockDataGood;
    mockDataGood[index].is_it_visible = value;
    this.setData({
      mockDataGood
    })
  },
  // 显示阶梯价弹窗
  showdelk(e) {
    let that = this;
    let index = e.currentTarget.dataset.index;
    if (that.data.bodytabindex == 2) {
      if (that.data.mockDataGood[index].step_price) {
        that.setData({
          show: true,
          currentPriceIndex: index,
          prices: that.data.mockDataGood[index].step_price
        })
      } else {
        that.setData({
          show: true,
          currentPriceIndex: index,
          prices: [{
              number: 0,
              price: ''
            },
            {
              number: '',
              price: ''
            }
          ]
        })
      }
    }
  },
  // 确认批发价
  confrimStepPrice() {
    let mockDataGood = this.data.mockDataGood;
    mockDataGood[this.data.currentPriceIndex].step_price = this.data.prices;
    this.setData({
      mockDataGood,
      show: false
    })
  },
  onClose() {
    this.setData({
      show: false
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // 获取分类列表
    wx.request({
      url: api.Classification_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          let foottab = that.data.foottab;
          foottab = foottab.concat(res.data.data);
          that.setData({
            foottab
          })
          // 获取帮卖商品列表
          that.getHelpsellList()
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        console.log(err);
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: async function () {
    let that = this;
    let result = await storageManager.get('subPageResult');
    if (result !== null) {
      for (let i = 0; i < result.length; i++) {
        result[i].xuan = false;
        result[i].is_it_visible = 0;
        delete result[i].step_price;
      }
      let mockDataGood = that.data.mockDataGood;
      mockDataGood = mockDataGood.concat(result);
      let newMockDataGood = that.removeDuplicateObj(mockDataGood);
      that.setData({
        mockDataGood: newMockDataGood
      })
      storageManager.set('subPageResult', null);
    }
    // 获取卖货团长列表
    that.getSellgoodsList()
  },
  // 数组去重
  removeDuplicateObj(arr) {
    let obj = {};
    arr = arr.reduce((newArr, next) => {
      obj[next.id] ? "" : (obj[next.id] = true && newArr.push(next));
      return newArr;
    }, []);
    return arr;
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 点击管理按钮
  clickManageBtn() {
    this.setData({
      openManageMode: !this.data.openManageMode
    })
  },
  // 点击管理按钮
  clickManageBtnGood() {
    this.setData({
      openManageModeGood: !this.data.openManageModeGood
    })
  },
  /* 帮卖商品 */
  // 获取帮卖商品
  getHelpsellList() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Helpsell_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        help_sell_application_status: that.data.bodytabindex,
        classification_id: that.data.foottab[that.data.leiindex].id,
        commodity_name: ''
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            mockDataGood: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        console.log(err);
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 从商品库添加
  addFromGoodsBank() {
    wx.navigateTo({
      url: '/pages/goodsbankselect/goodsbankselect',
    })
  },
  // 添加新商品
  addNewGoodsBank() {
    wx.navigateTo({
      url: '/pages/addtogood/addtogood',
    })
  },
  // 输入建议零售价
  inputRetailPrice(e) {
    let index = e.currentTarget.dataset.index;
    let mockDataGood = this.data.mockDataGood;
    mockDataGood[index].retail_price = e.detail.value;
    this.setData({
      mockDataGood
    })
  },
  // 输入起批数量
  inputStartingPurchase(e) {
    let index = e.currentTarget.dataset.index;
    let mockDataGood = this.data.mockDataGood;
    mockDataGood[index].starting_purchase = e.detail.value;
    this.setData({
      mockDataGood
    })
  },
  // 确认提交
  submitHelpSellAdd() {
    let that = this;
    let mockDataGood = that.data.mockDataGood;
    for (let i = 0; i < mockDataGood.length; i++) {
      mockDataGood[i].commodity_img = mockDataGood[i].commodity_img[0]
      delete mockDataGood[i].scribe_price
      delete mockDataGood[i].specifications
      delete mockDataGood[i].price
      delete mockDataGood[i].help_sell
      delete mockDataGood[i].stock
      delete mockDataGood[i].xuan
    }
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Helpsell_add,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        commodity_list: mockDataGood
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '添加成功',
            mask: true,
            success() {
              that.setData({
                mockDataGood: [],
                checkBoxResultGood: [],
                checkedAllGood: false
              })
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none',
            duration: 2000,
            success() {
              setTimeout(() => {
                if (res.data.msg === '请先进行个人认证') {
                  wx.navigateTo({
                    url: '/pages/phonenumber/phonenumber',
                  })
                }
              }, 2000)
            }
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        console.log(err);
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 复选框改变-帮卖商品
  checkBoxChangeGood(event) {
    let that = this;
    that.setData({
      checkBoxResultGood: event.detail,
    })
    const items = that.data.mockDataGood;
    const values = event.detail;
    for (let i = 0, lenI = items.length; i < lenI; ++i) {
      items[i].xuan = false
      for (let j = 0, lenJ = values.length; j < lenJ; ++j) {
        if (items[i].id == values[j]) {
          items[i].xuan = true
          break
        }
      }
    }
    that.setData({
      mockDataGood: items
    })
    if (event.detail.length == that.data.mockDataGood.length) {
      that.setData({
        checkedAllGood: true
      })
    } else {
      that.setData({
        checkedAllGood: false
      })
    }
  },
  // 全选复选框-帮卖商品
  selectAllGood() {
    // 先将checkBoxResult数组清空，之后将所有添加项上
    const items = this.data.mockDataGood;
    const checkBoxResultGood = [];
    for (let i = 0; i < items.length; i++) {
      items[i].xuan = true;
      checkBoxResultGood.push(items[i].id);
    }
    this.setData({
      mockDataGood: items,
      checkedAllGood: true,
      checkBoxResultGood: checkBoxResultGood
    })
  },
  // 取消全选-帮卖商品
  cancleAllGood() {
    const items = this.data.mockDataGood;
    for (let i = 0; i < items.length; i++) {
      items[i].xuan = false
    }
    this.setData({
      mockDataGood: items,
      checkedAllGood: false,
      checkBoxResultGood: []
    })
  },
  // 删除商品
  deleteGoods() {
    let that = this;
    if (that.data.checkBoxResultGood.length == 0) {
      wx.showToast({
        title: '请选择商品',
        icon: 'none',
        mask: true
      })
      return
    }
    let checkBoxResultGood = that.data.checkBoxResultGood.map(Number);
    if (that.data.bodytabindex == 2) {
      // 提交申请-删除本地商品
      let arr = that.data.mockDataGood;
      let arr2 = that.data.checkBoxResultGood;
      for (let i = 0; i < checkBoxResultGood.length; i++) {
        arr.splice(arr.findIndex(item => item.id === Number(checkBoxResultGood[i])), 1);
        arr2.splice(arr.findIndex(item => item === Number(checkBoxResultGood[i])), 1);
      }
      that.setData({
        mockDataGood: arr,
        checkBoxResultGood: arr2,
        checkedAllGood: false
      })
    } else {
      // 关联供应商和待审核-删除在线商品
      wx.showLoading({
        title: '删除中',
        mask: true
      })
      wx.request({
        url: api.Helpsell_delete,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          commodity_id: checkBoxResultGood
        },
        success(res) {
          console.log(res);
          wx.hideLoading()
          if (res.data.code === 1) {
            wx.showToast({
              title: '删除成功',
              icon: 'success',
              mask: true,
              success() {
                setTimeout(() => {
                  that.getHelpsellList()
                }, 1500)
              }
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        }
      })
    }
  },
  /* 卖货团长 */
  // 获取卖货团长列表
  getSellgoodsList() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Sellgoods_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        apply_status: that.data.bodytabindex2
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            mockData: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        console.log(err);
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 切换卖货团长tab
  bodytab2(e) {
    this.setData({
      bodytabindex2: e.currentTarget.dataset.index
    })
    this.getSellgoodsList()
  },
  // 跳转团长详情
  navToTuanZDetail2Status(e) {
    let id = e.currentTarget.dataset.id;
    let apply_status = e.currentTarget.dataset.status;
    let user_id = e.currentTarget.dataset.uid;
    let bodytabindex2 = this.data.bodytabindex2;
    if (this.data.bodytabindex2 == 2) {
      wx.navigateTo({
        url: '/pages/tuanzdetail2status/tuanzdetail2status?id=' + id + '&type=' + apply_status + '&uid=' + user_id
      })
    } else {
      wx.navigateTo({
        url: '/pages/tuanzdetail2status2/tuanzdetail2status2?id=' + id + '&type=' + apply_status + '&uid=' + user_id + '&bodytabindex2=' + bodytabindex2
      })
    }
  },
  // 不同意帮卖
  disagreeHelpSell() {
    let that = this;
    let apply_status = 2;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Sellgoods_status,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.checkBoxResult,
        apply_status: apply_status
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                that.setData({
                  openManageMode: false
                })
                that.getSellgoodsList()
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 同意帮卖
  agreeHelpSell() {
    let that = this;
    let apply_status = 1;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Sellgoods_status,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.checkBoxResult,
        apply_status: apply_status
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                that.setData({
                  openManageMode: false
                })
                that.getSellgoodsList()
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 复选框改变-卖货团长
  checkBoxChange(event) {
    let that = this;
    that.setData({
      checkBoxResult: event.detail,
    })
    const items = that.data.mockData;
    const values = event.detail;
    for (let i = 0, lenI = items.length; i < lenI; ++i) {
      items[i].xuan = false
      for (let j = 0, lenJ = values.length; j < lenJ; ++j) {
        if (items[i].id == values[j]) {
          items[i].xuan = true
          break
        }
      }
    }
    that.setData({
      mockData: items
    })
    if (event.detail.length == that.data.mockData.length) {
      that.setData({
        checkedAll: true
      })
    } else {
      that.setData({
        checkedAll: false
      })
    }
  },
  // 全选复选框-卖货团长
  selectAll() {
    // 先将checkBoxResult数组清空，之后将所有添加项上
    const items = this.data.mockData;
    const checkBoxResult = [];
    for (let i = 0; i < items.length; i++) {
      items[i].xuan = true;
      checkBoxResult.push(items[i].id);
    }
    this.setData({
      mockData: items,
      checkedAll: true,
      checkBoxResult: checkBoxResult
    })
  },
  // 取消全选-卖货团长
  cancleAll() {
    const items = this.data.mockData;
    for (let i = 0; i < items.length; i++) {
      items[i].xuan = false
    }
    this.setData({
      mockData: items,
      checkedAll: false,
      checkBoxResult: []
    })
  },
})