// pages/mine/mine.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    height: 0,
    tuan: false,
    isLogin: false, //是否登录
    showUserInfo: false, //控制用户头像与昵称显示
    code: '', //小程序授权Code
    avatarUrl: "/images/avatar.png", //这里放了一张灰色头像图片
    nickName: "请先登录", //用户昵称
    userinfo: {}, //用户信息
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      height: app.globalData.height
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    if (that.data.isLogin == false) {
      that.getCode()
    }
    //防止二次进入图片信息被隐藏
    if (wx.getStorageSync("login") == true) {
      that.setData({
        showUserInfo: true,
        isLogin: true,
        nickName: wx.getStorageSync('userinfo').name,
        avatarUrl: wx.getStorageSync('userinfo').headimg,
        userinfo: wx.getStorageSync('userinfo')
      })
    } else {
      that.setData({
        showUserInfo: false,
        isLogin: false,
      })
    }
    // 获取用户信息已刷新
    if (wx.getStorageSync('token')) {
      wx.request({
        url: api.user_info,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            wx.setStorageSync('userinfo', res.data.data);
            that.setData({
              userinfo: res.data.data,
              nickName: res.data.data.name,
              avatarUrl: res.data.data.headimg
            })
          }
        }
      })
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 用户登录
  login() {
    let that = this;
    wx.showLoading({
      title: '正在获取微信信息',
      mask: true
    })
    wx.getUserProfile({
      desc: '登录',
      success: (res) => {
        // console.log(res);
        wx.hideLoading()
        wx.showLoading({
          title: '登录中',
          mask: true
        })
        wx.request({
          url: api.weChatLogin,
          data: {
            code: that.data.code,
            headimg: res.userInfo.avatarUrl,
            name: res.userInfo.nickName
          },
          method: 'POST',
          success(res) {
            console.log(res);
            if (res.data.code === 1) {
              wx.setStorageSync('token', res.data.data);
              // 获取用户个人信息-开始
              wx.showLoading({
                title: '登录中',
                mask: true
              })
              wx.request({
                url: api.user_info,
                header: {
                  'Authorization': wx.getStorageSync('token')
                },
                success(res) {
                  console.log(res);
                  if (res.data.code === 1) {
                    wx.setStorageSync('login', true);
                    wx.setStorageSync('userinfo', res.data.data);
                    that.setData({
                      showUserInfo: true,
                      isLogin: true,
                      userinfo: res.data.data,
                      nickName: res.data.data.name,
                      avatarUrl: res.data.data.headimg
                    })
                  } else {
                    wx.showToast({
                      title: res.data.msg,
                      mask: true,
                      icon: 'none'
                    })
                  }
                },
                fail(err) {
                  wx.showToast({
                    title: '发起网络请求失败',
                    icon: 'none',
                    mask: true
                  })
                },
                complete() {
                  wx.hideLoading()
                }
                // 获取用户个人信息-结束
              })
            } else {
              wx.showToast({
                title: res.data.msg,
                mask: true,
                icon: 'none'
              })
            }
          },
          fail(err) {
            console.log(err);
          },
          complete() {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        wx.hideLoading()
        console.log(err);
      }
    })
  },
  // 获取小程序授权Code
  getCode() {
    let that = this;
    wx.login({
      success(res) {
        console.log(res);
        if (res.errMsg.search('ok')) {
          that.setData({
            code: res.code
          })
        } else {
          wx.showToast({
            title: res.errMsg,
            icon: 'error',
            mask: true
          })
        }
      }
    })
  },
  // 跳转我的主页
  navToMyHomePage(e) {
    let url = e.currentTarget.dataset.url;
    let id = this.data.userinfo.id;
    wx.navigateTo({
      url: url + '&id=' + id
    })
  },
  // 页面跳转通用
  navgo(e) {
    let url = e.currentTarget.dataset.url;
    wx.navigateTo({
      url: url
    })
  },
  qiehuan() {
    this.setData({
      tuan: !this.data.tuan
    })
  },
})