// pages/myorders/myorders.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '我的订单', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    tabs: [
      "全部", "待支付", "待收货", "退款/售后"
    ],
    zhong: 0,
    orders: [], //我的订单

    share_order_id: 0, //分享订单ID
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    // 获取我的订单列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Member_order,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            orders: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    let order_id = this.data.share_order_id; //订单ID
    return {
      title: '订单分享',
      path: '/pages/orderdetail/orderdetail?id=' + order_id,
      imageUrl: 'https://s4.ax1x.com/2021/12/29/TccgfK.jpg'
    }
  },
  tabsbind(e) {
    let that = this;
    let oid = e.currentTarget.dataset.id; //用户选中的标签
    let order_status = 0; //对应的订单状态
    if (oid === 0) {
      // 全部
      order_status = '';
    } else if (oid === 1) {
      // 待支付
      order_status = 0;
    } else if (oid === 2) {
      // 待取货
      order_status = 1;
    } else if (oid === 3) {
      // 已完成
      order_status = 2;
    } else if (oid === 4) {
      // 退款/售后
      order_status = 4;
    }
    if (oid === 0) {
      // 获取我的订单列表
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Member_order,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              orders: res.data.data,
              zhong: oid
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    } else {
      // 获取我的订单列表
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Member_order,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          order_status: order_status
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              orders: res.data.data,
              zhong: oid
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    }
  },
  // 订单跳转
  navToOrderDetail(e) {
    let id = e.currentTarget.dataset.id;
    let order_status = e.currentTarget.dataset.status;
    // console.log(order_status);
    if(order_status == 4) {
      wx.navigateTo({
        url: '/pages/confirmrefund/confirmrefund?id=' + id,
      })
    }else {
      wx.navigateTo({
        url: '/pages/orderdetail/orderdetail?id=' + id,
      })
    }
  },
    // 分享订单
    shareOrder(e) {
      this.setData({
        share_order_id: e.detail.value
      })
    }
})