const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '', //导航栏 中间的标题,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    orderStatus: 0, //订单状态/类型（0：交易完成；1：交易已取消；2：待取货；3：退款成功；4：待支付；）
    /* 组件参数 */
    showPopup: false, //显示确认框
    showPopupQRCode: false, //显示二维码
    /* 表单参数 */
    id: 0, //订单id
    order_info: {}, //订单信息
    user_info: {}, //用户信息
    commodity_list: [], //评论信息
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      id: Number(options.id)
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    // 获取订单详情
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Ordermanagement_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            order_info: res.data.data.order_info,
            user_info: res.data.data.user_info,
            commodity_list: res.data.data.commodity_list
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    let order_id = this.data.order_info.id; //订单ID
    return {
      title: '订单分享',
      path: '/pages/orderdetail/orderdetail?id=' + order_id,
      imageUrl: 'https://s4.ax1x.com/2021/12/29/TccgfK.jpg'
    }
  },
  // 联系团长
  callHead() {
    wx.makePhoneCall({
      phoneNumber: this.data.user_info.phone
    })
  },
  // 显示二维码
  openPopupQRCode() {
    this.setData({
      showPopupQRCode: true
    })
  },
  // 取消订单
  cancelOrder() {
    this.setData({
      showPopup: true
    })
  },
  // 申请退款
  requestRefund() {
    wx.navigateTo({
      url: '/pages/requestrefund/requestrefund',
    })
  },
  // 关闭弹出层
  closePopup() {
    this.setData({
      showPopup: false,
      showPopupQRCode: false
    })
  },
  // 仍要取消
  confirmCancel() {
    console.log('仍要取消');
    this.setData({
      showPopup: false
    })
  },
  // 修改订单信息
  changeOrder() {
    console.log('修改订单信息');
    this.setData({
      showPopup: false
    })
  },
  // 复制订单号
  copyOrderNumber() {
    wx.setClipboardData({
      data: this.data.order_info.order_number
    })
  }
})