// pages/pintuanchoose/pintuanchoose.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '拼团选择', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    icon: {
      normal: '../../images/unchecked.png',
      active: '../../images/checked.png',
    },
    pintuan: [],
    gang_name: '', //搜索
    time: -1, //防抖时间
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.getData()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 输入拼团名称
  inputGangName(e) {
    let that = this;
    that.setData({
      gang_name: e.detail.value
    })
    // 清除定时器
    clearTimeout(that.data.time);
    // 开启定时器
    this.data.time = setTimeout(() => {
      that.getData()
    }, 500)
  },
  // 获取拼团列表
  getData() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.OrderManagement_selection,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        gang_name: that.data.gang_name
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            pintuan: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 选择拼团
  selectPinTuan(e) {
    console.log(e);
    let item = e.currentTarget.dataset.item;
    wx.setStorageSync('pintuan', item);
    wx.navigateBack({
      delta: 1,
    })
  }
})