// pages/pintuandetail/pintuandetail.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    mode: '', //进入模式（manage: 拼团管理, dingyue: 订阅团长）
    height: 0,
    tabs: ['订单列表', '评价'],
    tabIndex: 0,
    goodCardMode: true, //商品卡片模式
    showGoodDetail: false, //显示商品详情
    showShoppingCart: false, //显示购物车
    guigeIndex: 0, //规格索引
    showManageMenu: false, //打开管理
    manageMenus: [{
      name: '编辑拼团'
    }],
    showBottomBar: true, //显示底部栏
    showAddComment: false, //弹出评论输入

    /* 表单 */
    id: 0, //拼团ID
    pintuandetail: {}, //拼团详情
    categorys: [{
      id: null,
      classification_name: '全部'
    }], //分类
    categoryIndex: 0,
    isSubscription: false, //是否订阅
    user_info: {}, //用户信息
    info: {}, //信息
    goods: [], //拼团商品列表
    currentGood: {}, //当前显示的商品详情
    currentGoodIndex: 0, //当前商品索引
    orders: [], //拼团订单列表
    comments: [], //拼团评论列表
    shopcart: [], //购物车
    all_scribe_price: 0, //划线价格总价
    all_price: 0, //实际价格总价

    /* 提交数据 */
    comment: '', //评论
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.setData({
      height: app.globalData.height
    })
    let id = Number(options.id);
    let mode = options.type;
    this.setData({
      mode,
      id
    })
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // 获取拼团详情信息
    wx.request({
      url: api.Gang_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            pintuandetail: res.data.data
          })
          if (that.data.pintuandetail.status == 2) {
            let manageMenus = that.data.manageMenus;
            manageMenus.push({
              name: '开启拼团'
            })
            that.setData({
              manageMenus
            })
          } else if (that.data.pintuandetail.status == 1) {
            let manageMenus = that.data.manageMenus;
            manageMenus.push({
              name: '截止拼团'
            })
            that.setData({
              manageMenus
            })
          }
          // 获取团长信息
          let user_id = res.data.data.user_id;
          wx.request({
            url: api.Head_info,
            header: {
              'Authorization': wx.getStorageSync('token')
            },
            data: {
              id: user_id,
            },
            success(res) {
              console.log(res);
              if (res.data.code === 1) {
                that.setData({
                  user_info: res.data.data.user_info,
                  isSubscription: res.data.data.subscribe === 1 ? true : false,
                  info: res.data.data.info
                })
              } else {
                wx.showToast({
                  title: res.data.msg,
                  mask: true,
                  icon: 'none'
                })
              }
            },
            fail(err) {
              wx.showToast({
                title: '发起网络请求失败',
                icon: 'none',
                mask: true
              })
            },
            complete() {
              wx.hideLoading()
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      }
    })
    // 商品分类列表
    wx.request({
      url: api.Classification_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          let arr = res.data.data;
          let categorys = that.data.categorys;
          categorys = categorys.concat(arr);
          that.setData({
            categorys
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    // 商品列表
    wx.request({
      url: api.Gang_commodity,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          for (let i = 0; i < res.data.data.length; i++) {
            res.data.data[i].count = 0; //新增商品数量字段
            // 如果为规格商品-增加类型、规格索引
            if (res.data.data[i].specifications) {
              res.data.data[i].type = 'guige';
              res.data.data[i].guige_index = 0;
            }
            // 如果为阶梯价商品-增加类型、阶梯价索引
            if (res.data.data[i].step_price) {
              res.data.data[i].type = 'step';
              res.data.data[i].step_index = 0;
            }
          }
          // 商品数量少于3时只能使用列表展示
          if(res.data.data.length>3){
            that.setData({
              goodCardMode: true
            })  
          }else{
            that.setData({
              goodCardMode: false
            })
          }
          that.setData({
            goods: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    // 拼团订单列表
    wx.request({
      url: api.Gang_order,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            orders: res.data.data
          })
        } else {
        //   wx.showToast({
        //     title: res.data.msg,
        //     mask: true,
        //     icon: 'none'
        //   })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    // 评论列表
    wx.request({
      url: api.Comment_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            comments: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    let pintuan_id = this.data.pintuandetail.id; //订单ID
    
    return {
      title: this.data.pintuandetail.user_info.name +'  '+ this.data.pintuandetail.gang_name,
      path: '/pages/pintuandetail/pintuandetail?type=dingyue&id=' + pintuan_id,
      imageUrl: this.data.pintuandetail.cover_img
    }
  },
  // 返回上一页
  _navback() {
    wx.navigateBack()
  },
  // 订阅
  subscription() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.subscribe,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.user_info.id
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            isSubscription: true
          })
          wx.showToast({
            title: res.data.msg,
            icon: 'success',
            mask: true
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 取消订阅
  noSubscription() {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.unsubscribe,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.user_info.id
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            isSubscription: false
          })
          wx.showToast({
            title: res.data.msg,
            icon: 'success',
            mask: true
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 打开管理菜单
  openManageMenu() {
    this.setData({
      showManageMenu: true,
      showBottomBar: false
    })
  },
  // 关闭管理菜单
  closeManageMenu() {
    this.setData({
      showManageMenu: false,
      showBottomBar: true
    })
  },
  // 选择分类
  changeCategory(e) {
    let that = this;
    let index = e.currentTarget.dataset.index;
    let classification_id = that.data.categorys[index].id;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // 商品列表
    wx.request({
      url: api.Gang_commodity,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id,
        classification_id: classification_id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          for (let i = 0; i < res.data.data.length; i++) {
            res.data.data[i].count = 0; //新增商品数量字段
            // 如果为规格商品-增加类型、规格索引
            if (res.data.data[i].specifications) {
              res.data.data[i].type = 'guige';
              res.data.data[i].guige_index = 0;
            }
            // 如果为阶梯价商品-增加类型、阶梯价索引
            if (res.data.data[i].step_price) {
              res.data.data[i].type = 'step';
              res.data.data[i].step_index = 0;
            }
          }
          that.setData({
            goods: res.data.data,
            categoryIndex: index,
            shopcart: [],
            all_price: 0,
            all_scribe_price: 0
          })
          if(res.data.data.length>3){
            that.setData({
              goodCardMode: true
            })  
          }else{
            that.setData({
              goodCardMode: false
            })
          }
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 切换商品卡片模式
  changeGoodCardMode() {
    this.setData({
      goodCardMode: !this.data.goodCardMode
    })
  },
  // 打开商品详情
  openGoodDetail(e) {
    let that = this;
    let index = Number(e.currentTarget.dataset.index);
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Commodity_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.goods[index].commodity_id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          let currentGood = res.data.data;
          if (that.data.goods[index].type == 'guige') {
            currentGood.type = that.data.goods[index].type;
            currentGood.guige_index = that.data.goods[index].guige_index;
          } else if (that.data.goods[index].type == 'step') {
            currentGood.type = that.data.goods[index].type;
            currentGood.step_index = that.data.goods[index].step_index;
          }
          that.setData({
            currentGood: res.data.data,
            currentGoodIndex: index,
            showGoodDetail: true,
            showShoppingCart: false
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 关闭商品详情
  closeGoodDetail() {
    this.setData({
      showGoodDetail: false,
      showShoppingCart: false
    })
  },
  // 切换订单列表与评价
  changeTab(e) {
    this.setData({
      tabIndex: e.currentTarget.dataset.index
    })
  },
  // 弹出购物车
  openShoppingCart() {
    this.setData({
      showShoppingCart: !this.data.showShoppingCart,
      showGoodDetail: false
    })
  },
  // 关闭购物车
  closeShoppingCart() {
    this.setData({
      showShoppingCart: false,
      showGoodDetail: false
    })
  },
  // 打开输入评论
  openAddComment() {
    this.setData({
      showAddComment: true,
      showBottomBar: false
    })
  },
  // 关闭输入评论
  closeAddComment() {
    this.setData({
      showAddComment: false,
      showBottomBar: true
    })
  },
  // 输入评论
  inputComment(e) {
    this.setData({
      comment: e.detail.value
    })
  },
  // 提交评论
  submitComment() {
    let that = this;
    if (that.data.comment == '') {
      wx.showToast({
        title: '请输入评论内容',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Comment_add,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id,
        content: that.data.comment
      },
      method: 'POST',
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '发表评论成功',
            mask: true
          })
          // 评论列表
          wx.request({
            url: api.Comment_list,
            header: {
              'Authorization': wx.getStorageSync('token')
            },
            data: {
              id: that.data.id
            },
            method: 'POST',
            success(res) {
              console.log(res);
              if (res.data.code === 1) {
                that.setData({
                  comment: '',
                  comments: res.data.data,
                  showAddComment: false
                })
              } else {
                wx.showToast({
                  title: res.data.msg,
                  mask: true,
                  icon: 'none'
                })
              }
            },
            fail(err) {
              wx.showToast({
                title: '发起网络请求失败',
                icon: 'none',
                mask: true
              })
            },
            complete() {
              wx.hideLoading()
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 选择商品规格
  selectCurrentGoodGuige(e) {
    let that = this;
    let index = Number(e.currentTarget.dataset.index); //当前选中的规格索引
    let currentGoodIndex = that.data.currentGoodIndex;
    let key = `goods[${currentGoodIndex}].guige_index`;
    let key2 = `currentGood.guige_index`;
    that.setData({
      [key]: index,
      [key2]: index
    })
    // 重新计算商品价格
    let goods = that.data.goods;
    let shopcart = [];
    let all_scribe_price = 0; //划线价格总价
    let all_price = 0; //实际价格总价
    for (let i = 0; i < goods.length; i++) {
      if (goods[i].count > 0) {
        // 计算划线价格总价
        all_scribe_price = all_scribe_price + (Number(goods[i].scribe_price) * Number(goods[i].count));
        // 计算商品价格
        if (goods[i].type == 'guige') {
          // 规格商品
          let guige_index = goods[i].guige_index;
          let price = Number(goods[i].specifications[guige_index].price); //商品当前规格单价
          all_price = all_price + (price * Number(goods[i].count));
        } else if (goods[i].type == 'step') {
          // 阶梯价商品
          let step_price = goods[i].step_price; //当前阶梯价商品的阶梯价
          // 冒泡排序-防止SB不按顺序输阶梯价-开始
          // for (let i = 0; i < step_price.length - 1; i++) { //确定轮数
          //   for (let j = 0; j < step_price.length - i - 1; j++) { //确定每次比较的次数
          //     if (step_price[j].number > step_price[j + 1].number) {
          //       let tem = step_price[j];
          //       step_price[j] = step_price[j + 1];
          //       step_price[j + 1] = tem;
          //     }
          //   }
          // }
          // 冒泡排序-防止SB不按顺序输阶梯价-结束
          let count = Number(goods[i].count); //数量
          let index = 0; //索引
          for (let i = 0; i < step_price.length; i++) {
            if (count > step_price[i].number) {
              index++;
            }
          }
          let key = `goods[${i}].step_index`
          that.setData({
            [key]: index
          })
          let step_index = goods[i].step_index;
          let price = Number(goods[i].step_price[step_index].price); //商品当前阶梯单价
          all_price = all_price + (price * Number(goods[i].count));
        }
        // 添加商品到购物车
        shopcart.push(goods[i]);
      }
    }
    that.setData({
      shopcart,
      all_price,
      all_scribe_price
    })
  },
  // 增加数量
  increaseCount(e) {
    let that = this;
    let id = e.currentTarget.dataset.id; //商品ID
    let index = that.data.goods.findIndex(item => item.commodity_id == id); //根据ID找出在goods中的索引
    let key = `goods[${index}].count`;
    that.setData({
      [key]: that.data.goods[index].count + 1
    })
    // 计算购物车
    let goods = that.data.goods;
    let shopcart = [];
    let all_scribe_price = 0; //划线价格总价
    let all_price = 0; //实际价格总价
    for (let i = 0; i < goods.length; i++) {
      if (goods[i].count > 0) {
        // 计算划线价格总价
        all_scribe_price = all_scribe_price + (Number(goods[i].scribe_price) * Number(goods[i].count));
        // 计算商品价格
        if (goods[i].type == 'guige') {
          // 规格商品
          let guige_index = goods[i].guige_index;
          let price = Number(goods[i].specifications[guige_index].price); //商品当前规格单价
          all_price = all_price + (price * Number(goods[i].count));
        } else if (goods[i].type == 'step') {
          // 阶梯价商品
          let step_price = goods[i].step_price; //当前阶梯价商品的阶梯价
          // 冒泡排序-防止SB不按顺序输阶梯价-开始
          // for (let i = 0; i < step_price.length - 1; i++) { //确定轮数
          //   for (let j = 0; j < step_price.length - i - 1; j++) { //确定每次比较的次数
          //     if (step_price[j].number > step_price[j + 1].number) {
          //       let tem = step_price[j];
          //       step_price[j] = step_price[j + 1];
          //       step_price[j + 1] = tem;
          //     }
          //   }
          // }
          // 冒泡排序-防止SB不按顺序输阶梯价-结束
          let count = Number(goods[i].count); //数量
          let index = 0; //索引
          for (let i = 0; i < step_price.length; i++) {
            if (count > step_price[i].number) {
              index++;
            }
          }
          let key = `goods[${i}].step_index`
          that.setData({
            [key]: index
          })
          let step_index = goods[i].step_index;
          let price = Number(goods[i].step_price[step_index].price); //商品当前阶梯单价
          all_price = all_price + (price * Number(goods[i].count));
        }
        // 添加商品到购物车
        shopcart.push(goods[i]);
      }
    }
    that.setData({
      shopcart,
      all_price,
      all_scribe_price
    })
  },
  // 减少数量
  decreaseCount(e) {
    let that = this;
    let id = e.currentTarget.dataset.id; //商品ID
    let index = that.data.goods.findIndex(item => item.commodity_id == id); //根据ID找出在goods中的索引
    let key = `goods[${index}].count`;
    that.setData({
      [key]: that.data.goods[index].count - 1
    })
    // 计算购物车
    let goods = that.data.goods;
    let shopcart = [];
    let all_scribe_price = 0; //划线价格总价
    let all_price = 0; //实际价格总价
    for (let i = 0; i < goods.length; i++) {
      if (goods[i].count > 0) {
        // 计算划线价格总价
        all_scribe_price = all_scribe_price + (Number(goods[i].scribe_price) * Number(goods[i].count));
        // 计算商品价格
        if (goods[i].type == 'guige') {
          // 规格商品
          let guige_index = goods[i].guige_index;
          let price = Number(goods[i].specifications[guige_index].price); //商品当前规格单价
          all_price = all_price + (price * Number(goods[i].count));
        } else if (goods[i].type == 'step') {
          // 阶梯价商品
          let step_price = goods[i].step_price; //当前阶梯价商品的阶梯价
          // 冒泡排序-防止SB不按顺序输阶梯价-开始
          // for (let i = 0; i < step_price.length - 1; i++) { //确定轮数
          //   for (let j = 0; j < step_price.length - i - 1; j++) { //确定每次比较的次数
          //     if (step_price[j].number > step_price[j + 1].number) {
          //       let tem = step_price[j];
          //       step_price[j] = step_price[j + 1];
          //       step_price[j + 1] = tem;
          //     }
          //   }
          // }
          // 冒泡排序-防止SB不按顺序输阶梯价-结束
          let count = Number(goods[i].count); //数量
          let index = 0; //索引
          for (let i = 0; i < step_price.length; i++) {
            if (count > step_price[i].number) {
              index++;
            }
          }
          let key = `goods[${i}].step_index`
          that.setData({
            [key]: index
          })
          let step_index = goods[i].step_index;
          let price = Number(goods[i].step_price[step_index].price); //商品当前阶梯单价
          all_price = all_price + (price * Number(goods[i].count));
        }
        // 添加商品到购物车
        shopcart.push(goods[i]);
      }
    }
    that.setData({
      shopcart,
      all_price,
      all_scribe_price
    })
  },
  // 清空购物车
  clearShopCart() {
    let that = this;
    let goods = that.data.goods;
    for (let i = 0; i < goods.length; i++) {
      goods[i].count = 0;
    }
    that.setData({
      goods: goods,
      shopcart: [],
      all_price: 0,
      all_scribe_price: 0
    })
  },
  // 下单
  placeOrder() {
    let that = this;
    // 已闭团无法购买商品
    if (that.data.pintuandetail.status == 0) {
      wx.showToast({
        title: '该拼团已结束，无法下单',
        mask: true,
        icon: 'none'
      })
      return
    }
    // 超出库存数量无法购买商品
    for (let i = 0; i < that.data.shopcart.length; i++) {
      if (that.data.shopcart[i].count > that.data.shopcart[i].stock) {
        wx.showToast({
          title: that.data.shopcart[i].commodity_name + '的购买数量超出库存数量',
          mask: true,
          icon: 'none',
          duration: 2000
        })
        return
      }
    }
    let id = that.data.id; //拼团id
    let gang_name = that.data.pintuandetail.gang_name; //拼团名称
    let all_scribe_price = that.data.all_scribe_price; //原价
    let all_price = that.data.all_price; //总价
    let shopcart = that.data.shopcart; //购物车
    let logistics_mode = that.data.pintuandetail.logistics_mode; //物流方式（0没有物流，1取货点自提，2送货或者自提）
    let head_phone = that.data.user_info.phone; //团长手机号
    let userName = that.data.user_info.name; //团长名称
    let expected_arrival_time = that.data.pintuandetail.expected_arrival_time; //预计到货时间
    if (shopcart.length > 0) {
      wx.setStorageSync('shopcart', shopcart);
      wx.navigateTo({
        url: '/pages/confirmorder/confirmorder?id=' + id + '&all_scribe_price=' + all_scribe_price + '&all_price=' + all_price + '&gang_name=' + gang_name + '&logistics_mode=' + logistics_mode + '&head_phone=' + head_phone + '&expected_arrival_time=' + expected_arrival_time + '&user_name=' + userName,
      })
    } else {
      wx.showToast({
        title: '购物车为空',
        mask: true,
        icon: 'none'
      })
    }
  },
  // 节点跳转
  goAnchorPoint(e) {
    let type = e.currentTarget.dataset.type;
    if (type == 'comment') {
      this.setData({
        tabIndex: 1
      })
    } else {
      this.setData({
        tabIndex: 0
      })
    }
    let id = e.currentTarget.dataset.id;
    //1、返回一个查询实例
    const query = wx.createSelectorQuery();
    //2、选择要跳转的节点id
    query.select(id).boundingClientRect();
    //3、获取显示区域的尺寸、滚动等位置等信息，然后添加节点的滚动位置查询
    query.selectViewport().scrollOffset();
    //4、执行跳转
    query.exec((res) => {
      //5、res[0]是步骤2中的数据，res[1]是步骤3中的数据
      if (res[0] && res[1]) {
        //6、将页面滚动到目标位置
        wx.pageScrollTo({
          //7、计算滚动到目标的位置
          scrollTop: res[0].top + res[1].scrollTop,
          duration: 300
        })
      }
    });
  },
  // 管理拼团菜单
  selectManageMenu(e) {
    if (e.detail.name == '编辑拼团') {
      // console.log('编辑拼团');
      let id = this.data.pintuandetail.id;
      wx.navigateTo({
        url: '/pages/announce/announce?type=edit&id=' + id,
      })
    } else if (e.detail.name == '开启拼团') {
      // console.log('开启拼团');
      let that = this;
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Gang_open,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          id: that.data.pintuandetail.id
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            wx.showToast({
              title: '开启拼团成功',
              icon: 'success',
              mask: true,
              success() {
                setTimeout(() => {
                  wx.navigateBack({
                    delta: 1,
                  })
                }, 1500)
              }
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    } else if (e.detail.name == '截止拼团') {
      // console.log('截止拼团');
      let that = this;
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Gang_by,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          id: that.data.pintuandetail.id
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            wx.showToast({
              title: '截止拼团成功',
              icon: 'success',
              mask: true,
              success() {
                setTimeout(() => {
                  wx.navigateBack({
                    delta: 1,
                  })
                }, 1500)
              }
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          // wx.hideLoading()
        }
      })
    }
  }
})