// pages/requestrefund/requestrefund.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '退款申请', //导航栏 中间的标题,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    id: 0, //订单ID
    order_info: {}, //订单信息
    user_info: {}, //用户信息
    commodity_list: [], //评论信息

    refund_reason: '', //退款原因
    refund_voucher: '', //凭证
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log(options);
    let that = this;
    let id = Number(options.id);
    that.setData({
      id
    })
    // 获取订单详情
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Order_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            order_info: res.data.data.order_info,
            user_info: res.data.data.user_info,
            commodity_list: res.data.data.commodity_list
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 输入退款原因
  inputReason(e) {
    this.setData({
      refund_reason: e.detail.value
    })
  },
  // 上传退款凭证
  uploadVoucher() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        wx.chooseMedia({
          count: 1,
          mediaType: ['image'],
          success: (img) => {
            console.log(img);
            let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
            wx.showLoading({
              title: '文件上传中',
              mask: true
            })
            wx.uploadFile({
              filePath: img.tempFiles[0].tempFilePath,
              name: 'file',
              url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
              formData: {
                key: key,
                policy: oss.data.data.policy, // 输入你获取的的policy
                OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                signature: oss.data.data.Signature, // 输入你获取的的signature
              },
              success: (res) => {
                if (res.statusCode == 200) {
                  let src = 'https://' + oss.data.data.host + '/' + key;
                  that.setData({
                    refund_voucher: src
                  })
                }
              },
              fail: (err) => {
                console.log(err);
              },
              complete: () => {
                wx.hideLoading()
              }
            })
          },
          fail: (err) => {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 撤销退款
  cheXiaoTuiKuan() {
    wx.navigateBack({
      delta: 1,
    })
  },
  // 确认退款
  confirmRefund() {
    let that = this;
    if (that.data.refund_reason == '') {
      wx.showToast({
        title: '退款原因未录入',
        icon: 'none',
        mask: true
      })
      return
    }
    if (that.data.refund_voucher == '') {
      wx.showToast({
        title: '退款凭证图片未上传',
        icon: 'none',
        mask: true
      })
      return
    }
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Order_refund,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.order_info.id,
        refund_reason: that.data.refund_reason,
        refund_voucher: that.data.refund_voucher
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          wx.navigateTo({
            url: '/pages/confirmrefund/confirmrefund?id=' + that.data.order_info.id
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  }
})