// pages/returnofgoods/returnofgoods.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '退货管理', //导航栏 中间的标题,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    tabs: ["全部", "未处理", "已处理"],
    indexs: 0,
    pintuan: [],
    pintuanIndex: 0,
    listdata: [],
    commodityIndex: 0
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    // 获取团长详情-拼团列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Head_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: wx.getStorageSync('userinfo').id,
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            pintuan: res.data.data.gang_list
          })
          // 获取数据
          that.getData();
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 获取数据
  getData() {
    let that = this;
    // 团长退货管理列表
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.ReturnGoods_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        refund_status: that.data.indexs,
        id: that.data.pintuan[that.data.pintuanIndex].id
      },
      method: 'POST',
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            listdata: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  // 切换拼团
  pintuanChange(e) {
    this.setData({
      pintuanIndex: Number(e.detail.value)
    })
    this.getData()
  },
  // 切换Tab
  tabs(e) {
    this.setData({
      indexs: e.currentTarget.dataset.ind
    })
    this.getData()
  },
  // 跳转详情
  navToDetail(e) {
    let item = e.currentTarget.dataset.item;
    let id = item.id;
    if(item.refund_status == 2) {
      // 未处理
      wx.navigateTo({
        url: '/pages/returnofmoney/returnofmoney?id=' + id,
      })
    }else {
      // 已处理
      wx.navigateTo({
        url: '/pages/returnofdetail/returnofdetail?id=' + id,
      })
    }
  }
})