// pages/search/search.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '搜索', //导航栏 中间的标题,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    news: [], //历史搜索
    dingyues: [], //团长列表
    show: false,
    isShowSearchResult: false,
    keywords: '', //搜索关键字
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    // 获取
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Head_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            dingyues: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  delhis() {
    this.setData({
      show: true
    })
  },
  onClose() {
    this.setData({
      show: false
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getSearchList()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 获取历史搜索记录
  getSearchList() {
    let that = this;
    // 获取用户历史搜索
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Search_list,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            news: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },
  inputKeyWords(e) {
    console.log(e.detail.value)
    if (e.detail.value === '') {
      this.setData({
        keywords: e.detail.value,
        isShowSearchResult: false
      })
      let that = this;
      // 获取
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Head_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              dingyues: res.data.data
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
      that.getSearchList()
    } else {
      this.setData({
        keywords: e.detail.value
      })
    }
  },
  // 搜索
  search() {
    let that = this;
    if (that.data.keywords !== '') {
      // console.log('搜索：' + this.data.keywords);
      // 获取订阅团长列表
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Head_list,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        data: {
          name: that.data.keywords
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            that.setData({
              dingyues: res.data.data,
              isShowSearchResult: true
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    }
  },
  // 点击历史搜索
  clickHistoryItem(e) {
    this.setData({
      keywords: e.currentTarget.dataset.name
    })
  },
  // 删除所有历史搜索记录
  confirmDelete() {
    let that = this;
    let arr = [];
    if(that.data.news.length == 0){
      wx.showToast({
        title: '暂无记录，无需删除',
        icon: 'none',
        mask: true
      })
      return
    }
    for (let i = 0; i < that.data.news.length; i++) {
      arr.push(that.data.news[i].id)
    }
    wx.showLoading({
      title: '删除中',
      mask: true
    })
    wx.request({
      url: api.Search_delete,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: arr
      },
      success(res) {
        console.log(res);
        wx.hideLoading()
        if (res.data.code === 1) {
          wx.showToast({
            title: '删除成功',
            mask: true,
            icon: 'none',
            success() {
              that.setData({
                show: false
              })
              setTimeout(()=>{
                that.getSearchList()
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 团长跳转
  navToTuanZhang(e) {
    let url = e.currentTarget.dataset.url;
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: url + '&id=' + id
    })
  },
})