// pages/helpsell/helpsell.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    height: 0,
    classify: [],
    sidetabs: [{
      id: null,
      classification_name: '全部'
    }],
    pintuan: [],
    showphone: false,
    phone: [{
      name: ''
    }],
    showfen: false,
    fenxiang: [{
      name: '分享给朋友'
    }, {
      name: '分享到朋友圈'
    }],
    sideindex: 0,
    enterType: 0, //进入类型（0：供应大厅；1：正在帮卖；2：我的申请-未审核-审核中；3：我的申请-已审核-审核拒绝；4：我的申请-已审核-审核同意；）
    /* 表单 */
    id: 0, //团长id
    commodity_list: [], //商品列表
    info: {}, //拼团信息
    user_info: {}, //用户信息
  },
  _navback() {
    wx.navigateBack()
  },
  // 显示分享菜单
  showfens() {
    this.setData({
      showfen: true
    })
  },
  // 点击切换侧边栏
  sidetap(e) {
    this.setData({
      sideindex: e.currentTarget.dataset.index
    })
  },
  // 显示拨打电话菜单
  showphones() {
    this.setData({
      showphone: true
    })
  },
  // 关闭
  offzhe() {
    this.setData({
      showfen: false,
      showphone: false
    })
  },
  // 确认拨打电话
  phoneok(e) {
    wx.makePhoneCall({
      phoneNumber: e.detail.name,
    })
  },
  // 编辑团长信息
  gobianji() {
    wx.navigateTo({
      url: '/pages/userinfo/userinfo',
    })
  },
  // 点击分享
  fenok(e) {
    console.log("我点击分享了")
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      height: app.globalData.height
    })
    this.setData({
      id: Number(options.id),
      enterType: Number(options.type)
    })
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Supplyhall_head_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.id
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          let arr = that.data.sidetabs;
          arr = arr.concat(res.data.data.classification_info);
          that.setData({
            classify: res.data.data.classification_info,
            commodity_list: res.data.data.commodity_list,
            info: res.data.data.info,
            user_info: res.data.data.user_info,
            phone: [{
              name: res.data.data.user_info.phone
            }],
            sidetabs: arr
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 申请帮卖
  applyHelpSell() {
    let that = this;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Supplyhall_apply,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.id
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none',
            duration: 2000,
            success() {
              setTimeout(() => {
                if (res.data.msg === '请先进行个人认证') {
                  wx.navigateTo({
                    url: '/pages/phonenumber/phonenumber',
                  })
                }
              }, 2000)
            }
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 取消帮卖
  cancelHelpSale() {
    let that = this;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Cancel_help_sale,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.id
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 跳转团长微信二维码
  navToWXQrcode() {
    let headimg = this.data.user_info.headimg;
    let name = this.data.user_info.name;
    let wechat_code = this.data.user_info.wechat_code;
    wx.navigateTo({
      url: '/pages/wxqrcode/wxqrcode?headimg=' + headimg + '&name=' + name + '&wechat_code=' + wechat_code
    })
  },
})