// pages/helpsell/helpsell.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1,
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    height: 0,
    classify: [
      "生鲜", "教育", "熟食", "生鲜", "教育", "熟食", "甜点糕点", "生活用品"
    ],
    sidetabs: ["全部", "肉类", "海鲜", "教育", "熟食", "生活用品"],
    showphone: false,
    phone: [{
      name: ''
    }],
    showfen: false,
    fenxiang: [{
      name: '分享给朋友'
    }, {
      name: '分享到朋友圈'
    }],
    sideindex: 0,
    enterType: 0, //进入类型
    /* 表单 */
    id: 0, //申请表ID
    uid: 0, //团长ID
    user_info: {}, //用户信息
    info: {}, //信息
    pintuan: [], //拼团列表
    detail: {}, //详情
    bodytabindex2: 0, //(0:关联供应商；1：待审核；2：已审核)
  },
  _navback() {
    wx.navigateBack()
  },
  showfens() {
    this.setData({
      showfen: true
    })
  },
  sidetap(e) {
    this.setData({
      sideindex: e.currentTarget.dataset.index
    })
  },
  showphones() {
    this.setData({
      showphone: true
    })
  },
  offzhe() {
    this.setData({
      showfen: false,
      showphone: false
    })
  },
  phoneok(e) {
    wx.makePhoneCall({
      phoneNumber: e.detail.name,
    })
  },
  gobianji() {
    wx.navigateTo({
      url: '/pages/userinfo/userinfo',
    })
  },
  fenok(e) {
    if (e.detail.name === '分享给朋友') {
      console.log('分享朋友');
    } else {
      wx.navigateTo({
        url: '/pages/sharetofirend/sharetofirend',
      })
    }
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    this.setData({
      height: app.globalData.height,
      enterType: Number(options.type),
      id: Number(options.id),
      uid: Number(options.uid),
      bodytabindex2: Number(options.bodytabindex2)
    })
    console.log(options);
    // 获取团长详情
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.Head_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.uid,
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            user_info: res.data.data.user_info,
            classify: res.data.data.classification_info,
            info: res.data.data.info,
            pintuan: res.data.data.gang_list,
            phone: [{
              name: res.data.data.user_info.phone
            }]
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
    wx.request({
      url: api.Sellgoods_time,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        id: that.data.id,
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            detail: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 跳转团长微信二维码
  navToWXQrcode() {
    let headimg = this.data.user_info.headimg;
    let name = this.data.user_info.name;
    let wechat_code = this.data.user_info.wechat_code;
    wx.navigateTo({
      url: '/pages/wxqrcode/wxqrcode?headimg=' + headimg + '&name=' + name + '&wechat_code=' + wechat_code
    })
  },
  // 取消帮卖
  cancelHelpSale() {
    let that = this;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Cancel_help_sale,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: that.data.user_info.id
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 不同意帮卖
  disagreeHelpSell() {
    let that = this;
    let id = this.data.id;
    let apply_status = 2;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Sellgoods_status,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: [id],
        apply_status: apply_status
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 同意帮卖
  agreeHelpSell() {
    let that = this;
    let id = this.data.id;
    let apply_status = 1;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    wx.request({
      url: api.Sellgoods_status,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        id: [id],
        apply_status: apply_status
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
})