// pages/userinfo/userinfo.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    show: false, //显示二维码
    userinfo: {},
    /* 表单 */
    headimg: '', //用户头像
    phone: '', //用户手机号
    address: '', //用户地址
    wechat_number: '', //用户微信号
    wechat_code: '', //用户微信二维码
    email: '', //用户邮箱
    introduction: '', //用户简介
    background_img: '', //用户主页背景图
    collection_code: '', //用户收款码
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let userinfo = wx.getStorageSync('userinfo');
    this.setData({
      userinfo: userinfo,
      headimg: userinfo.headimg,
      phone: userinfo.phone,
      address: userinfo.address,
      wechat_number: userinfo.wechat_number,
      wechat_code: userinfo.wechat_code,
      email: userinfo.email,
      introduction: userinfo.introduction,
      background_img: userinfo.background_img,
      collection_code: userinfo.collection_code
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },
  showpopup() {
    this.setData({
      show: true
    })
  },
  onClose() {
    this.setData({
      show: false
    })
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 上传头像
  uploadAvatar() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        wx.chooseMedia({
          count: 1,
          mediaType: ['image'],
          success: (img) => {
            console.log(img);
            let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
            wx.showLoading({
              title: '文件上传中',
              mask: true
            })
            wx.uploadFile({
              filePath: img.tempFiles[0].tempFilePath,
              name: 'file',
              url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
              formData: {
                key: key,
                policy: oss.data.data.policy, // 输入你获取的的policy
                OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                signature: oss.data.data.Signature, // 输入你获取的的signature
              },
              success: (res) => {
                if (res.statusCode == 200) {
                  let src = 'https://' + oss.data.data.host + '/' + key;
                  console.log(src);
                  that.setData({
                    headimg: src
                  })
                }
              },
              fail: (err) => {
                console.log(err);
              },
              complete: () => {
                wx.hideLoading()
              }
            })
          },
          fail: (err) => {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 输入联系电话
  inputPhone(e) {
    this.setData({
      phone: e.detail.value
    })
  },
  // 输入地址
  inputAddress(e) {
    this.setData({
      address: e.detail.value
    })
  },
  // 输入微信号
  inputWechatNumber(e) {
    this.setData({
      wechat_number: e.detail.value
    })
  },
  // 上传微信二维码
  uploadWechatCode() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        wx.chooseMedia({
          count: 1,
          mediaType: ['image'],
          success: (img) => {
            console.log(img);
            let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
            wx.showLoading({
              title: '文件上传中',
              mask: true
            })
            wx.uploadFile({
              filePath: img.tempFiles[0].tempFilePath,
              name: 'file',
              url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
              formData: {
                key: key,
                policy: oss.data.data.policy, // 输入你获取的的policy
                OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                signature: oss.data.data.Signature, // 输入你获取的的signature
              },
              success: (res) => {
                if (res.statusCode == 200) {
                  let src = 'https://' + oss.data.data.host + '/' + key;
                  console.log(src);
                  that.setData({
                    wechat_code: src
                  })
                }
              },
              fail: (err) => {
                console.log(err);
              },
              complete: () => {
                wx.hideLoading()
              }
            })
          },
          fail: (err) => {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 输入邮箱
  inputEmail(e) {
    this.setData({
      email: e.detail.value
    })
  },
  // 输入简介
  inputIntroduction(e) {
    this.setData({
      introduction: e.detail.value
    })
  },
  // 上传主页背景
  uploadBackgroundImg() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        wx.chooseMedia({
          count: 1,
          mediaType: ['image'],
          success: (img) => {
            console.log(img);
            let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
            wx.showLoading({
              title: '文件上传中',
              mask: true
            })
            wx.uploadFile({
              filePath: img.tempFiles[0].tempFilePath,
              name: 'file',
              url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
              formData: {
                key: key,
                policy: oss.data.data.policy, // 输入你获取的的policy
                OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                signature: oss.data.data.Signature, // 输入你获取的的signature
              },
              success: (res) => {
                if (res.statusCode == 200) {
                  let src = 'https://' + oss.data.data.host + '/' + key;
                  console.log(src);
                  that.setData({
                    background_img: src
                  })
                }
              },
              fail: (err) => {
                console.log(err);
              },
              complete: () => {
                wx.hideLoading()
              }
            })
          },
          fail: (err) => {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 上传用户收款码
  uploadCollectionCode() {
    let that = this;
    // wx.showLoading({
    //   title: '文件上传中',
    //   mask: true
    // })
    wx.request({
      url: api.getSignedUrl,
      data: {
        type: 'image'
      },
      success: (oss) => {
        console.log(oss);
        wx.chooseMedia({
          count: 1,
          mediaType: ['image'],
          success: (img) => {
            console.log(img);
            let key = "image/" + new Date().getTime() + Math.floor(Math.random() * 150) + '.png';
            wx.showLoading({
              title: '文件上传中',
              mask: true
            })
            wx.uploadFile({
              filePath: img.tempFiles[0].tempFilePath,
              name: 'file',
              url: 'https://' + oss.data.data.host, //输入你的bucketname.endpoint
              formData: {
                key: key,
                policy: oss.data.data.policy, // 输入你获取的的policy
                OSSAccessKeyId: oss.data.data.OSSAccessKeyId, // 输入你的AccessKeyId
                success_action_status: '200', // 让服务端返回200,不然，默认会返回204
                signature: oss.data.data.Signature, // 输入你获取的的signature
              },
              success: (res) => {
                if (res.statusCode == 200) {
                  let src = 'https://' + oss.data.data.host + '/' + key;
                  console.log(src);
                  that.setData({
                    collection_code: src
                  })
                }
              },
              fail: (err) => {
                console.log(err);
              },
              complete: () => {
                wx.hideLoading()
              }
            })
          },
          fail: (err) => {
            wx.hideLoading()
          }
        })
      },
      fail: (err) => {
        console.log(err);
      }
    })
  },
  // 确认添加
  submit() {
    let that = this;
    wx.showLoading({
      title: '提交中',
      mask: true
    })
    // if (that.data.headimg == '') {
    //   wx.showToast({
    //     title: '用户头像未上传',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.phone == '') {
    //   wx.showToast({
    //     title: '联系电话未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.address == '') {
    //   wx.showToast({
    //     title: '地址未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.wechat_number == '') {
    //   wx.showToast({
    //     title: '微信号未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.wechat_code == '') {
    //   wx.showToast({
    //     title: '微信二维码未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.email == '') {
    //   wx.showToast({
    //     title: '邮箱地址未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.introduction == '') {
    //   wx.showToast({
    //     title: '用户简介未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.background_img == '') {
    //   wx.showToast({
    //     title: '用户主页背景图未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    // if (that.data.collection_code == '') {
    //   wx.showToast({
    //     title: '用户收款码未录入',
    //     icon: 'none',
    //     mask: true
    //   })
    //   return
    // }
    wx.request({
      url: api.edit_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      method: 'POST',
      data: {
        headimg: that.data.headimg,
        phone: that.data.phone,
        address: that.data.address,
        wechat_number: that.data.wechat_number,
        wechat_code: that.data.wechat_code,
        email: that.data.email,
        introduction: that.data.introduction,
        background_img: that.data.background_img,
        collection_code: that.data.collection_code
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: '提交成功',
            icon: 'success',
            mask: true,
            success() {
              app.getUserDetailInfo()
              setTimeout(() => {
                wx.navigateBack({
                  delta: 1,
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        // wx.hideLoading()
      }
    })
  },
  // 立即去认证
  navToRZ() {
    wx.navigateTo({
      url: '/pages/phonenumber/phonenumber',
    })
  },
})