const app = getApp();
const api = require('../../api/api');
Page({

  /** 
   * 页面的初始数据 
   */
  data: {
    Length: 4, //输入框个数  
    isFocus: true, //聚焦  
    phone: '', //手机号
    Value: "", //输入的内容（验证码）
    ispassword: false, //是否密文显示 true为密文， false为明文。
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '个人认证', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
  },
  onLoad(options) {
    console.log(options);
    this.setData({
      phone: options.phone
    })
  },
  Focus(e) {
    let that = this;
    let inputValue = e.detail.value;
    that.setData({
      Value: inputValue,
    })
    if (that.data.Value.length === that.data.Length) {
      wx.showLoading({
        title: '正在验证',
        mask: true
      })
      wx.request({
        url: api.authentication,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        data: {
          phone: that.data.phone,
          code: that.data.Value
        },
        success(res) {
          wx.hideLoading()
          console.log(res);
          if (res.data.code === 1) {
            wx.showToast({
              title: res.data.msg,
              icon: 'success',
              mask: true,
              success() {
                setTimeout(() => {
                  wx.navigateTo({
                    url: '/pages/authorizesuccessful/authorizesuccessful',
                  })
                }, 1500)
              }
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none',
              duration: 2000
            })
            // that.setData({
            //   Value: '',
            //   isFocus: false
            // })
            setTimeout(()=> {
              // that.setData({
              //   isFocus: true
              // })
              let options = {phone: wx.getStorageSync('phonenumber')}
              that.onLoad(options)
            }, 1000)
          }
        },
        fail(err) {
          wx.hideLoading()
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {

        }
      })
    }
  },
  Tap() {
    var that = this;
    that.setData({
      isFocus: true,
    })
  },
  formSubmit(e) {
    console.log(e.detail.value.password);
  },
  // 方案2：输入完成
  inputComplated(e) {
    // console.log(e.detail.value);
    // return
    let that = this;
    let inputValue = e.detail.value;
    that.setData({
      Value: inputValue,
    })
    wx.showLoading({
      title: '正在验证',
      mask: true
    })
    wx.request({
      url: api.authentication,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      data: {
        phone: that.data.phone,
        code: that.data.Value
      },
      success(res) {
        wx.hideLoading()
        console.log(res);
        if (res.data.code === 1) {
          wx.showToast({
            title: res.data.msg,
            icon: 'success',
            mask: true,
            success() {
              setTimeout(() => {
                wx.navigateTo({
                  url: '/pages/authorizesuccessful/authorizesuccessful',
                })
              }, 1500)
            }
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none',
            duration: 2000
          })
        }
      },
      fail(err) {
        wx.hideLoading()
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {

      }
    })
  }
})