// pages/withdraw/Withdraw.js
const app = getApp();
const api = require('../../api/api');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navbarData: {
      showCapsule: 1, //是否显示左上角图标   1表示显示    0表示不显示
      title: '', //导航栏 中间的标题
      capsuleMode: 'navBack', //显示模式（navBack：返回上一页；navHome：返回首页）
    },
    actions: [{
      id: 0,
      name: "公司银行转账"
    }, {
      id: 1,
      name: "个人转账"
    }, {
      id: 2,
      name: "EMT"
    }, {
      id: 3,
      name: "联系客服"
    }],
    show: false,
    userinfo: {},
    wechat: ''
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.request({
      url: api.user_info,
      header: {
        'Authorization': wx.getStorageSync('token')
      },
      success(res) {
        console.log(res);
        if (res.data.code === 1) {
          that.setData({
            userinfo: res.data.data
          })
        } else {
          wx.showToast({
            title: res.data.msg,
            mask: true,
            icon: 'none'
          })
        }
      },
      fail(err) {
        wx.showToast({
          title: '发起网络请求失败',
          icon: 'none',
          mask: true
        })
      },
      complete() {
        wx.hideLoading()
      }
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  butsel(e) {
    let that = this;
    if (e.detail.id === 0) {
      // console.log('公司银行转账');
      wx.navigateTo({
        url: '/pages/corporatebanktransfer/corporatebanktransfer?withdrawal_method=' + e.detail.id + '&balance=' + this.data.userinfo.balance,
      })
    } else if (e.detail.id === 1) {
      // console.log('个人转账');
      wx.navigateTo({
        url: '/pages/corporatebanktransfer/corporatebanktransfer?withdrawal_method=' + e.detail.id + '&balance=' + this.data.userinfo.balance,
      })
    } else if (e.detail.id === 2) {
      // console.log('EMT');
      wx.navigateTo({
        url: '/pages/corporatebanktransfer/corporatebanktransfer?withdrawal_method=' + e.detail.id + '&balance=' + this.data.userinfo.balance,
      })
    } else if (e.detail.id === 3) {
      // console.log('联系客服');
      wx.showLoading({
        title: '加载中',
        mask: true
      })
      wx.request({
        url: api.Withdrawalmanagement_apply,
        header: {
          'Authorization': wx.getStorageSync('token')
        },
        method: 'POST',
        data: {
          withdrawal_method: 3
        },
        success(res) {
          console.log(res);
          if (res.data.code === 1) {
            let key = 'actions[3].name'
            that.setData({
              wechat: res.data.data.wechat,
              [key]: '客服微信号：' + res.data.data.wechat
            })
          } else {
            wx.showToast({
              title: res.data.msg,
              mask: true,
              icon: 'none'
            })
          }
        },
        fail(err) {
          wx.showToast({
            title: '发起网络请求失败',
            icon: 'none',
            mask: true
          })
        },
        complete() {
          wx.hideLoading()
        }
      })
    }
  },
  record(e) {
    wx.navigateTo({
      url: '/pages/companyrecord/companyrecord',
    })
  },
  detail() {
    wx.navigateTo({
      url: '/pages/companydetailgroup/companydetailgroup',
    })
  },
  quxiao() {
    this.setData({
      show: false
    })
  },
  showsel() {
    this.setData({
      show: true
    })
  },
})